define(function (require, exports, module) {
	var appUtils = require("appUtils"),
		gconfig = require("gconfig"),
		layerUtils = require("layerUtils"),
		keyPaneArray = ["0","1","2","3","4","5","6","7","8","9"],
		keyPanelHtml = "<div class=\"word_table\" id=\"keyPanel_tel\" style=\"display:none\">"+
			    "<table width=\"100%\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\" class=\"word_abc_table\">"+
			          "<tr class=\"col4\">"+
			            "<td><a herf=\"javascript:void(0)\" class='panelNum'>1</a></td>"+
						"<td><a herf=\"javascript:void(0)\" class='panelNum'>2</a></td>"+
						"<td><a herf=\"javascript:void(0)\" class='panelNum'>3</a></td>"+
			          "</tr>"+
			          "<tr class=\"col4\">"+
			            "<td><a herf=\"javascript:void(0)\" class='panelNum'>4</a></td>"+
						"<td><a herf=\"javascript:void(0)\" class='panelNum'>5</a></td>"+
						"<td><a herf=\"javascript:void(0)\" class='panelNum'>6</a></td>"+
			          "</tr>"+
			          "<tr class=\"col4\">"+
			            "<td><a herf=\"javascript:void(0)\" class='panelNum'>7</a></td>"+
						"<td><a herf=\"javascript:void(0)\" class='panelNum'>8</a></td>"+
						"<td><a herf=\"javascript:void(0)\" class='panelNum'>9</a></td>"+
			          "</tr>"+
			          "<tr class=\"col3\">"+
			          "<td><a class=\"hide\">&nbsp;</a></td>"+
					  "<td><a herf=\"javascript:void(0)\" class='panelNum'>0</a></td>"+
					  "<td><a class=\"del\">&nbsp;</a></td>"+
			          "</tr>"+
			    "</table>"+
			"</div>",
		    curKeyPanl = "keyPanel_tel",//当前面板
		    offsetTop = 0,//当前键盘弹出后input距离顶部上移的距离
		    curUi = null,//当前元素的父元素，用于计算input距离顶部的高度
		    callback = null;//回调
	appUtils.loadCssArray(["../1.2.2/plugins/keypanel_used/css/keyPanel.css","../1.2.2/plugins/keypanel_used/css/autocomplete.css"]); //加载所需的css

	/**
	 * 键盘初始化
	 * callback
	 * curUi 当前激活的div键盘
	 */
	function init_keyPanel(_callback,_curUi)
	{
		//alert(roundNum);
		callback = _callback;
		curUi = _curUi;
		keyPanelChange(curKeyPanl,curUi);
		if(gconfig.global.hasBottomNav && (gconfig.platform == 1 || gconfig.platform == 2)){
			require("shellPlugin").callShellMethod("hideMenuPlugin",function(){},function(){},{"visible":"false"});
		}
	}
	
	/**
	 * 随机数键盘处理
	 */
	function roundKeyPanel()
	{
		var arrayTest = [];
		while (arrayTest.length != 10) {
			var roundNum = Math.floor(Math.random()*10);
			if($.inArray(roundNum,arrayTest)==-1)
				{
					arrayTest.push(roundNum);
				}
		}
		
		for (var int = 0; int < arrayTest.length; int++) 
		{
			$(".panelNum").eq(int).html(arrayTest[int]);
		}
		//alert(arrayTest);
	}
	
	
	/**
	 * 键盘添加监听
	 **/
	function addKeyPanel(ui)
	{
		appUtils.bindEvent($("#" + ui), function(e){
			e.preventDefault();
		}, "touchmove");
		
		appUtils.bindEvent($("#"+ui+" a"),function(e){
			$(this).addClass("active");
			var evt = e|| window.event;
	        evt.stopPropagation ? evt.stopPropagation() : (evt.cancelBubble=true);
		},"touchstart");
		
		appUtils.bindEvent($("#"+ui+" a"),function(e){
			$(this).removeClass("active");
			//增加样式
			var ele = e.srcElement?e.srcElement:e.target;
			var curKey = ele.className;
			var blank = "&nbsp;";
			var cur = ele.innerHTML;
			
			if(curKey == "hide")//关闭键盘
			{
				closeKeyPanel();
				return false;
			}	
			else if(curKey == "del")//回退
			{
				cur = "del";
			}
			if(callback)
			{
				callback(cur);
			}
//			roundKeyPanel();
			var evt = e|| window.event;
			curUi && curUi.parent().find("input").trigger("input");
	        evt.stopPropagation ?evt.stopPropagation() : (evt.cancelBubble=true);
		},"touchend");
		
		appUtils.bindEvent($("#"+ui+" p"),function(e){
			$(this).addClass("active");
	        var evt = e|| window.event;
	        evt.stopPropagation ?evt.stopPropagation() : (evt.cancelBubble=true);
		},"touchstart");
		
		appUtils.bindEvent($("#"+ui+" p"),function(e){
			$(this).removeClass("active");
			closeKeyPanel();
	        var evt = e|| window.event;
	        evt.stopPropagation ?evt.stopPropagation() : (evt.cancelBubble=true);
		},"touchend");
	}
	/**
	 * 关闭输入法
	 * 
	 **/
	function closeKeyPanel()
	{
		if($("#"+curKeyPanl).length > 0)
		{
			$("#"+curKeyPanl).slideUp("fast",function(e){
				$(this).remove();
				/**
				 * 如果使用键盘的页面有安卓的原生底部导航，在关闭键盘的时候显示底部导航
				 */
				if(gconfig.global.hasBottomNav && (gconfig.platform == 1 || gconfig.platform == 2))
				{
					require("shellPlugin").callShellMethod("hideMenuPlugin",function(){},function(){},{"visible":"true"});
				}
			});
			
			if(curUi)
			{
				if(curUi.parents(".main").length >0)
				{	
					curUi.parents(".main").css("margin-top","0px");
				}else if(curUi.parents(".pop_confirm").length >0)
				{
					var marinTop = curUi.parents(".pop_confirm").css("margin-top");
					marinTop = Number(marinTop.slice(0, -2));
					curUi.parents(".pop_confirm").css("margin-top", (marinTop + offsetTop) + "px");
				}	
			}	
		}
	}
	
	/**
	 * 切换输入法
	 **/
	function keyPanelChange(tabPanel,curUi)
	{
		var word_table = $("#"+tabPanel);
		if(word_table.length <= 0)
		{
			
			$("body").append(keyPanelHtml);
			roundKeyPanel();
		}
		addKeyPanel("keyPanel_tel");
		$("#"+tabPanel).slideDown("fast");
		$("#"+tabPanel).css("display","block").siblings(".word_table").css("display","none");
		setTimeout(function(){
			var keyBoardHeight = $("#"+tabPanel).height();//键盘的高度
			var keyBoardScrllTop = (curUi.offset().top+curUi.height()+20);//键盘距离顶部的高度
			var windowHeight = $(window).height();
			if((keyBoardScrllTop+keyBoardHeight) > windowHeight )
			{
				offsetTop = (keyBoardScrllTop+keyBoardHeight)  - windowHeight;
				if(curUi)
				{
					if(curUi.parents(".main").length >0)
					{	
						curUi.parents(".main").css("margin-top",-offsetTop+"px");
					}else if(curUi.parents(".pop_confirm").length >0)
					{
						var marinTop = curUi.parents(".pop_confirm").css("margin-top");
						marinTop = Number(marinTop.slice(0, -2));
						curUi.parents(".pop_confirm").css("margin-top",marinTop - offsetTop+"px");
					}	
				}	
			}		
		}, 200);
	}
	
	var keyPanel = {
		"init_keyPanel" : init_keyPanel,
		"closeKeyPanel" :closeKeyPanel
	};

	//暴露对外的接口
	module.exports = keyPanel;	
});