/**
 * 程序入口配置读取
 * 项目开发时需要的自定义配置
 */
define(function(require, exports, module) {
	var configuration = {
		/*******************************************必配项***************************************************/
		/**
		 * 平台，不传默认为0：
		 * 0：pc或者手机浏览器、1：android手机壳子嵌phonegap、2：ios手机壳子嵌phonegap、
		 * 3：ios手机壳子嵌AIR、4：android手机跳转web、5：ios手机跳转web、
		 * 默认为：0
		 */

		/**
		 * 项目的默认页面，当在地址栏输入的url不带pageCode（“#!/”至“.html”中间的部分）时进入该配置对应的页面，
		 * 这个参数是不带pageCode时进入默认页面的入参
		 * 默认为：{}
		 */
		"defaultPage": {"pageCode": "account/msgVerify", "jsonParam":{}},
		/******************************************选择可配项************************************************/
		/**
		 * hSea根路径，项目中的文件uri最终会在项目访问的web路径后添加
		 */
		/**
		 * 项目模块名，默认为project
		 */
		"projName": "project",
		/**
		 * 项目中的需要先加载的css样式文件，如果多个，添加在数组里面中，从css目录下写文件路径
		 * 不配默认为：["/css/app_style.css"]
		 */
		"firstLoadCss": ["/css/style.css","/css/style_new.css"],
		/**
		 * 后台返回结果集出参结构，类似error_no、error_info的出参命名定义，
		 * 防止不同项目的后台的出参命名不一致，以便框架可取配置的值，由项目自己定义，但后台必须统一
		 * 不配默认为：{"error_no": "error_no", "error_info": "error_info"}
		 */
		"resultsParser": {"error_no": "error_no", "error_info": "error_info"},
		/**
		 * 前端根据后台的error_no做的过滤器配置，需要后台配合定义error_no，
		 * 有的需要跳转页面，有的只做提示，提示信息如果后台给出，就取后台提示信息，否则取配置中的error_info字段
		 * 不配默认为：{}
		 */
		"filters": {

			"-999": {"pageCode": "account/msgVerify", "jsonParam": {}, "error_info":"请先登录"} //用户没有登陆
	//		"-999": {"moduleAlias":"common", "moduleFuncName":"filterLoginOut"} //用户没有登陆或者登陆超时
		},
		/**
		 * 整个项目的登录页面
		 * 不配默认为：{}
		 */
		"loginPage": {"pageCode": "account/msgVerify", "jsonParam":{}},
		/**
		 * 项目中公用模块的别名配置
		 * 不配默认为：{}
		 */
		"pAlias": {
	//		"keyTelPanel": "plugins/keypanel/scripts/keyTelPanel",
			"utils": "project/scripts/common/utils",
	        "domain": "project/scripts/thinkive/domain",
        	"common": "project/scripts/common/common",
	        "serviceImp": "project/service/investService",
	        "base": "project/scripts/common/base",
	        "announcementAndUpdate": "project/scripts/common/announcementAndUpdate"
		},
//		/**
//		 * 权限校验规则，提供在外面的方法
//		 * common为项目通用模块配置的别名，checkPermission方法里面写校验规则，返回true或者false，避免写异步的代码
//		 * 不配默认为：{}
//		 */
		"checkPermission": {"moduleAlias":"common", "moduleFuncName":"checkPermission"},
//		/**
//		 * 第一次加载第一个业务模块前所需要的处理，即启动之后提供给外界初始化的接口，
//		 * 这个方法中避免写异步操作，或者保证异步影响其他代码逻辑
//		 * common为项目通用模块配置的别名，firstLoadFunc为执行的方法
//		 * 这个配置可以做很多事情，当你从业务模块逻辑上不好实现时，可以考虑这里！！
//		 * 不配默认为：{}
//		 */
		"firstLoadIntf": {"moduleAlias": "common", "moduleFuncName":"firstLoadFunc"},
		/**
		 * 项目中需要调用到的常量、变量这里配置，调用方式，通过require("gconfig").global.*来调用
		 * 不配默认为：{}
		 */
		"global": {
			"protocol":"ajax", //协议
			"needConfirm":true,  //需要页面上进行用户回访
			"aesKey":88888888,  // 加密串
			"channelInfo" : "3",	//渠道信息（ 1-建设银行 ; 3-标准版 ; 4 - 中国银行  ;  6-工商银行 ; 7-表示雪球 ; 9-光大银行  ;）
			"Province_name":"上海",
			"City_name":"上海",
			"Branch_name":"互联网金融营业部",
			"BranchNo":"GDYBSH0800",
			"linkurl":"http://www.baidu.com",//分享的地址
			"brokerno":"5206",//百度 5206  易创5207
			"appType" : "1",	//app类型（ 1-标准版(点金门) ; 2-引流(独立互联网); 3-掌上富尊、金阳光 ）
			"tzqxName":"您用于证券投资的大部分资金不会用作其它用途的时间段为",
			"tzpzName":"您打算重点投资于哪些种类的投资品种",
			"ans_A":"2026",
			"ans_B":"2026.2027",
			"ans_C":"2026.2027.2028",
			"ans_D":"2026.2027.2028.2029",
			"ans_E":"2030",
		//	"serverUrl": "http://10.0.29.154:81", 	// 光大 --内网仿真测试环境
		//	"serverPath": "http://10.0.29.154:81/servlet/json" 	// 光大 --内网仿真测试环境
			"serverUrl":"https://ekh.ebscn.com/",  //光大图片地址
			"serverPath": "https://ekh.ebscn.com/servlet/json" 	// 光大 --生产环境

//			"serverUrl":"http://www.thinkive.cn:5051",
//			"serverPath": "http://www.thinkive.cn:5053/servlet/json" // 开户 --公司测试环境


			//"serverUrl":"http://10.0.74.49:81",
			//"serverPath": "http://10.0.74.49:81/servlet/json" // 开户 --内仿真环境
			//"serverUrl":"http://116.236.247.175:20081",
			//"serverPath": "http://116.236.247.175:20081/servlet/json" // 开户 --光大外网仿真*/
		},
		/**
		 * 弹出层各种弹出层主题样式，默认为系统自带
		 * 不配默认为："default"
		 */
		"layerTheme": "d"
	};

	//暴露对外的接口
	module.exports = window.configuration = configuration;
});
