/**
 * 填写个人信息
 */
define(function(require, exports, module){
	/* 私有业务模块的全局变量 begin */
	var appUtils = require("appUtils"),
	    service = require("serviceImp").getInstance(),  //业务层接口，请求数据
		global = require("gconfig").global,
		layerUtils = require("layerUtils"),
		utils = require("utils"),
		manId = "",
		womenId = "",
		validatorUtil = require("validatorUtil"),
		idCardModify = false,  // 身份证是否被手工修改
		_pageId = "#account_personInfo";
	/* 私有业务模块的全局变量 end */

	function init()
	{
		layerUtils.iLoading(true);	//开启等待层
		cleanPageElement();  // 清除页面元素
//		window.calendarCallback = calendarCallback;  // 全局调用日期插件方法
		//  从上传照片页面进入
		if(appUtils.getSStorageInfo("_prePageCode") == "account/uploadPhoto" || appUtils.getSStorageInfo("_prePageCode") == "account/uploadPhotoChange")
		{
			// 根据传入的值，填充页面的数据
			$(_pageId+" .name").val(appUtils.getPageParam("custname"));	  // 客户姓名
			$(_pageId+" .idCardNo").val(appUtils.getPageParam("idno"));	 // 身份证号

			$(_pageId+" .ethnicname").val(appUtils.getPageParam("ethnicname"));	 // 民族

			$(_pageId+" .signDepartment").val(appUtils.getPageParam("policeorg"));	// 签发机关
			$(_pageId+" .idCardAddress").val(appUtils.getPageParam("native"));	// 证件地址
			$(_pageId+" .address").val(appUtils.getPageParam("native"));	// 联系地址和证件地址设置相同的
			$(_pageId+" .idBeginDate").val(appUtils.getPageParam("idbegindate"));  //起始期限

			if(appUtils.getPageParam("idenddate") == "3000-12-31"){
				$(_pageId+" .idEndDate1").val("长期");  //结束期限
				$(_pageId+" #endDate1").css("display","none");
				$(_pageId+" #endDate").css("display","block");
			}else{
				$(_pageId+" #endDate").css("display","none");
				$(_pageId+" #endDate1").css("display","block");
				$(_pageId+" .idEndDate").val(appUtils.getPageParam("idenddate"));  //结束期限
			}

			$(_pageId+" .zipCode").val(appUtils.getPageParam("postid"));  //邮编
			// 如果是由新开流程跳转到转户流程， 并且有设置过学历和职业，那么初始化页面时,
			// 职业和学历和上次的选择保持不变
			var photosInfo = appUtils.getSStorageInfo("photosInfo");
			if(appUtils.getSStorageInfo("photosInfo") != null)
			{
				photosInfo = JSON.parse(photosInfo);
			}
			// 显示之前所选职业
			if(photosInfo != null && photosInfo.isChangeProcess == "true" && photosInfo.fillInformationInParam.occupation.text != "请选择职业")
			{
				$(_pageId+" .selectOccupation").text(photosInfo.fillInformationInParam.occupation.text);
				$(_pageId+" .selectOccupation").attr("value",photosInfo.fillInformationInParam.occupation.value);
			}
			// 显示之前所选学历
			if(photosInfo != null && photosInfo.isChangeProcess == "true" && photosInfo.fillInformationInParam.degree.text != "请选择学历")
			{
				$(_pageId+" .selectDegree").text(photosInfo.fillInformationInParam.degree.text);
				$(_pageId+" .selectDegree").attr("value",photosInfo.fillInformationInParam.degree.value);
			}
			// 显示之前所选税收居民信息
			if(photosInfo != null && photosInfo.isChangeProcess == "true" && photosInfo.fillInformationInParam.taxresident.text != "请选择税收居民信息")
			{
				$(_pageId+" .taxresident").text(photosInfo.fillInformationInParam.taxresident.text);
				$(_pageId+" .taxresident").attr("value",photosInfo.fillInformationInParam.taxresident.value);
			}
			queryDataDict();  // 获取职业和学历列表
		}
		else
		{
			$(_pageId+" .name").val(appUtils.getSStorageInfo("custname"));	  // 客户姓名
			$(_pageId+" .idCardNo").val(appUtils.getSStorageInfo("idCardNo"));	 // 身份证号

			$(_pageId+" .ethnicname").val(appUtils.getSStorageInfo("ethnicname"));	 // 民族

			$(_pageId+" .signDepartment").val(appUtils.getSStorageInfo("policeorg"));	// 签发机关
			$(_pageId+" .idCardAddress").val(appUtils.getSStorageInfo("native"));	// 证件地址
			$(_pageId+" .address").val(appUtils.getSStorageInfo("addr"));	 // 联系地址和证件地址设置相同的
			$(_pageId+" .zipCode").val(appUtils.getSStorageInfo("postid"));  //邮编
			$(_pageId+" .idBeginDate").val(appUtils.getSStorageInfo("idbegindate"));  // 证件开始日期
			if(appUtils.getSStorageInfo("idenddate") == "3000-12-31" || appUtils.getSStorageInfo("idenddate") =="长期"){

				$(_pageId+" .idEndDate1").val("长期");  //结束期限
				$(_pageId+" #endDate1").css("display","none");
				$(_pageId+" #endDate").css("display","block");
			}else{
				$(_pageId+" #endDate").css("display","none");
				$(_pageId+" #endDate1").css("display","block");
				$(_pageId+" .idEndDate").val(appUtils.getSStorageInfo("idenddate"));  //结束期限
			}
//			$(_pageId+" .idEndDate").val(appUtils.getSStorageInfo("idenddate"));  // 证件结束日期

			queryDataDict();  // 获取职业和学历列表
		}

	}

	function bindPageEvent()
	{
		/*绑定右上角退出事件*/
		appUtils.bindEvent($(_pageId+" .header .btn-close"),function(){
			layerUtils.iConfirm("只需三分钟就能搞定网上开户,确定离开吗?",function(){
				var param = {
		 				"moduleName":"open",
		 				"funcNo":"50114",
		 				"params":{
		 				}
		 			};
				require("external").callMessage(param);
			},function(){},"离开","继续开户");
		});

		/* 绑定返回 */
		appUtils.bindEvent($(_pageId+" .header .icon_back"),function(){
			pageBack();
		});

		/* 点击页面其他元素隐藏下拉列表 */
		appUtils.bindEvent($(_pageId),function(e){
			// 隐藏下拉列表
			$(_pageId+" .sel_list").slideUp("fast",function(){
				$("body #bodyContent").css("overflow","auto");
			});
			e.stopPropagation();	// 阻止冒泡
		});

//		//键盘弹起来时撑起界面
//		appUtils.bindEvent($(_pageId+" .input_form input"),function(e){
//			var id = "#"+$(this).attr("id"); //当前input元素id
//
//			var pwsdParam = {"isShow":true,"oldPwd":$(this).val(),"maxLength":100};
//			var topHeight = $(this).offset().top+$(this).parent().height();  //当前元素到顶部的高度
//			var bodyHeight = $(document.body).height();  //当前body的高度
//			if(platform == '1'){
//				require("shellPlugin").callShellMethod("softKeyboardPlugin",function(data){
//					//解决弹出键盘遮挡输入框的情况
//					var keyheight = data.height/window.devicePixelRatio; //键盘高度
//					var newbody = bodyHeight - keyheight; // 键盘弹出 body的高度
//					var scrollheight = topHeight - newbody; // 输入框被遮住的高度
//					if(scrollheight>0) //只有当密码键盘挡住输入框的时候才进行处理
//					{
//						scrollheight2 = bodyHeight - $(_pageId).height() + scrollheight; //页面需要滚动的高度
//						$("body").css("padding-bottom",scrollheight2+"px").scrollTop(scrollheight);
//					}
//				},null,pwsdParam);
//			}
//			e.stopPropagation();	// 阻止冒泡
//		});		
		
		/* 选择职业、学历、税收居民信息 */
		appUtils.bindEvent($(_pageId+" .sel_text"),function(e){
			var n = $(this).parent().index();
			$(_pageId+" .sel_list ul li").removeClass("active");
			// 隐藏其他下拉列表
			for(var i = 0;i<$(_pageId+" .sel_text").length;i++){
				if(i != n){
					$(_pageId+" .sel_list:eq("+i+")").slideUp("fast",function(){
						$("body #bodyContent").css("overflow","auto");
					});	
				}
			}
			// 显示选择职业、学历和税收居民信息的下拉列表
			$(_pageId+" .sel_list:eq("+n+")").slideDown("fast",function(){
				$("body #bodyContent").css("overflow","hidden");
			});
			e.stopPropagation();	// 阻止冒泡
		});
		
		
//		/* 选择职业 */
//		appUtils.bindEvent($(_pageId+" .selectOccupation"),function(e){
//			$(_pageId+" .job ul li").removeClass("active");
//			// 显示选择职业的下拉列表
//			$(_pageId+" .sel_list:eq(0)").slideDown("fast",function(){
//				$("body #bodyContent").css("overflow","hidden");
//			});		
//			e.stopPropagation();	// 阻止冒泡
//		});
//		
//		/* 选择学历 */
//		appUtils.bindEvent($(_pageId+" .selectDegree"),function(e){
//			$(_pageId+" .education ul li").removeClass("active");
//			// 显示选择学历的下拉列表
//			$(_pageId+" .sel_list:eq(1)").slideDown("fast",function(){
//				$("body #bodyContent").css("overflow","hidden");
//			});	
//			e.stopPropagation(); // 阻止冒泡
//		});
//		
//		/* 选择居民税收信息 */
//		appUtils.bindEvent($(_pageId+" .taxresident"),function(e){
//			$(_pageId+" .taxInfo ul li").removeClass("active");
//			// 显示选择税收居民信息的下拉列表
//			$(_pageId+" .sel_list:eq(2)").slideDown("fast",function(){
//				$("body #bodyContent").css("overflow","hidden");
//			});	
//			e.stopPropagation(); // 阻止冒泡
//		});
		
		
/*		 限制名字的长度 
		appUtils.bindEvent($(_pageId+" .name"),function(){
			utils.dealIPhoneMaxLength(this,8);  //处理iphone兼容
		},"input");*/

		/* 限制身份证的长度 */
		appUtils.bindEvent($(_pageId+" .idCardNo"),function(){
			$(this).val($(this).val().toUpperCase());//存在字母时改为大写
			utils.dealIPhoneMaxLength(this,18);  //处理iphone兼容
		},"input");


		/* 绑定选择日期的事件 */
		appUtils.bindEvent($(_pageId+" input[date-plugin='true']"),function(e){
			utils.selectDate(this);  // 通过壳子调用系统的日历插件
		});

		/* 绑定下一步 */
		appUtils.bindEvent($(_pageId+" .fix_bot .ct_btn"),function(){
			if(verifyInfo())  // 校验数据
			{
				submitInfo();  //提交用户信息
			}
		});

		//选择账户使用情况和诚信记录
		appUtils.bindEvent(_pageId+" .apts_input_select a",function(){
			//判断当前是否选中
			if(!$(this).hasClass("active")){
				$(this).addClass("active").parent().siblings().find("a").removeClass("active");
			}
		});
	}
	//通过身份证号获取出生日期数字
	var getBirthDate = function(idCardNo){
		var date = "";
		if(idCardNo){
			if(idCardNo.length == 15){
				date = idCardNo.substring(6,8)+"/"+idCardNo.substring(8,10)+"/"+idCardNo.substring(10,12);
			}else if(idCardNo.length == 18){

				date = idCardNo.substring(6,10)+"/"+idCardNo.substring(10,12)+"/"+idCardNo.substring(12,14);
			}
			return date;
		}
	}
	/* 处理返回按钮 */
	function pageBack()
	{
		var currentStep = appUtils.getSStorageInfo("currentStep");
		// 当前完成步骤为：已成功上传身份证 或者 由视频返回到资料提交页，处理返回按钮
		if(appUtils.getSStorageInfo("personInfo") == "exist" || currentStep == "uploadimg")
		{
			appUtils.setSStorageInfo("currentStep","uploadimg");
			appUtils.setSStorageInfo("idInfo","exist");  // 标记用户完成照片上传
			appUtils.pageInit("account/personInfo","account/uploadPhoto",{});
		}
		// 正常开户处理返回按钮
		else
		{
//			appUtils.pageBack();
			appUtils.pageInit("account/personInfo","account/uploadPhoto",{});
		}
	}

	function destroy()
	{
		service.destroy();
	}

	/*提交开户信息*/
	function submitInfo()
	{
		// 开户信息资料提交
		var param = setSubmitDataParam();
		service.submitUserInfo(param,function(data){
			var error_no = data.error_no;
			var error_info = data.error_info;
			if(error_no == 0)
			{
				appUtils.setSStorageInfo("idCardNo",$(_pageId+" .idCardNo").val());
				appUtils.setSStorageInfo("custname",$(_pageId+" .name").val());
				appUtils.setSStorageInfo("taxresident",$(_pageId+" .taxresident").val());

				//新开，则走新开流程
				if(appUtils.getSStorageInfo("openChannel") == "new")
				{
					// 跳转到视频见证页面
					appUtils.pageInit("account/personInfo","account/videoNotice",{});
				}
				// 转户，则走转户流程
				else if(appUtils.getSStorageInfo("openChannel") == "change")
				{
					appUtils.pageInit("account/personInfo","account/videoNotice",{});
//					// 转户，模拟视频见证通过，否则下载证书的时候后台  会出现 cert_uid 错误
//					var syncQQUserInfoParam = {
//						user_id : appUtils.getSStorageInfo("user_id")
//					};
//					// 模拟视频通过
//					service.syncQQUserInfo(syncQQUserInfoParam,function(data){
//						var error_no = data.error_no;
//						var error_info = data.error_info;
//						if(error_no == 0)
//						{
//							// 跳转到数字证书页面
//							appUtils.pageInit("account/personInfo","account/digitalCertificate",{});
//						}
//						else
//						{
//							layerUtils.iLoading(false);
//							layerUtils.iAlert(error_info,-1);
//						}
//					});
				}
			}
			// 转户走了新开，提示走转户
			else if(error_no == -50152819)
			{
				layerUtils.iLoading(false);
				utils.layerTwoButton("系统检测到您已开立证券账户为：【"+error_info+"】，请进行转户流程!","马上转户","退出系统",function(){
					changeState(); // 走转户流程
				},function(){
					require("shellPlugin").callShellMethod("closeAppPlugin",null,null);  // 退出系统
				});
			}
			// 新开走了转户，提示走新开流程
			else if(error_no == -50152820)
			{
				appUtils.setSStorageInfo("idCardNo",$(_pageId+" .idCardNo").val());
				appUtils.setSStorageInfo("custname",$(_pageId+" .name").val());
				layerUtils.iLoading(false);
				utils.layerTwoButton("您未开通股东账户，请走新开流程!","立即开户","退出系统",function(){
					newOpen();  //走新开流程
				},function(){
					require("shellPlugin").callShellMethod("closeAppPlugin",null,null);  // 退出系统
				});
			}
			// 新开查到单边市场
			else if(error_no == -50152829)
			{
				appUtils.setSStorageInfo("idCardNo",$(_pageId+" .idCardNo").val());
				appUtils.setSStorageInfo("custname",$(_pageId+" .name").val());
				layerUtils.iLoading(false);
				utils.layerTwoButton("系统检测到您已开立证券账户为：【"+error_info+"】","继续开户","马上转户",function(){
					newOpen();  // 走新开流程
				},function(){
					changeState(); // 走转户流程
				});
			}
			else
			{
				layerUtils.iLoading(false);
				layerUtils.iAlert(data.error_info);  // 填写资料失败，弹出提示
			}
		},false);
	}

	/* 改变流程状态，走转户 */
	function changeState()
	{
		// session中的openChannel改为转户
		appUtils.setSStorageInfo("openChannel","change");
		var newopenParam = {
			user_id : appUtils.getSStorageInfo("user_id"),
			uploadimg_flag:"0",
			opacctkind_flag:"1"  // 转户
		}
		service.queryChangeState(newopenParam,function(data){
			var error_no = data.error_no;
			var error_info = data.error_info;
			if(error_no == 0)
			{
				// 跳转之前，修改 session 中 photosInfo 的 fillInformationInParam
				var photosInfo = JSON.parse(appUtils.getSStorageInfo("photosInfo"));
				// 设置 photosInfo 的 isChangeProcess 属性，true 是更改流程
				photosInfo.isChangeProcess = true;
				photosInfo.fillInformationInParam.idno = $(_pageId+" .idCardNo").val();
				photosInfo.fillInformationInParam.custname = $(_pageId+" .name").val();
				photosInfo.fillInformationInParam.native = $(_pageId+" .idCardAddress").val();  // 证件地址
				photosInfo.fillInformationInParam.policeorg = $(_pageId+" .signDepartment").val();  // 签发机关
				photosInfo.fillInformationInParam.birthday = $(_pageId+" .idCardNo").attr("birthday");  // 出生日期
				photosInfo.fillInformationInParam.idbegindate = "";
				photosInfo.fillInformationInParam.idenddate = $(_pageId+" .idEndDate").val();
				photosInfo.fillInformationInParam.postid = $(_pageId+" .zipCode").val();  // 邮政编码
				if($(_pageId+" .idEndDate1").val() == "长期" && $(_pageId+" #endDate").css("display") =="block"){
					photosInfo.fillInformationInParam.idbegindate = "长期";
				}else{
					photosInfo.fillInformationInParam.idbegindate = $(_pageId+" .idEndDate").val();
				}
				// 职业
				photosInfo.fillInformationInParam.occupation = {
					"text" : $(_pageId+" .selectOccupation").text(),
					"value" : $(_pageId+" .selectOccupation").attr("value")
				};
				// 学历
				photosInfo.fillInformationInParam.degree = {
					"text" : $(_pageId+" .selectDegree").text(),
					"value" : $(_pageId+" .selectDegree").attr("value")
				};
				//税收居民信息
				photosInfo.fillInformationInParam.taxresident = {
					"text" : $(_pageId+" .taxresident").text(),
					"value" : $(_pageId+" .taxresident").attr("value")
				};
				// 重新设置  session 中 photosInfo
				appUtils.setSStorageInfo("photosInfo",JSON.stringify(photosInfo));
				// 跳到转户的上传照片页面
				appUtils.pageInit("account/personInfo","account/uploadPhotoChange",{});
			}
			else
			{
				layerUtils.iLoading(false);
				layerUtils.iAlert(data.error_info,-1);
			}
		},false);
	}

	/*走新开户*/
	function newOpen()
	{
		// session中的openChannel改为新开
		appUtils.setSStorageInfo("openChannel","new");
		var newopenParam = {
			user_id : appUtils.getSStorageInfo("user_id"),
			uploadimg_flag:"1",  //身份证上传成功
			opacctkind_flag:"0"  //新开户
		}
		service.queryChangeState(newopenParam,function(data){
			var error_no = data.error_no;
			var error_info = data.error_info;
			if(error_no == 0)
			{
				// 再次调用提交用户信息接口, 添加入参submitflag =0
				var param = setSubmitDataParam();
				param.submitflag = "0" ;
				service.submitUserInfo(param,function(data){
					var error_no = data.error_no;
					var error_info = data.error_info;
					if(error_no == 0)
					{
						appUtils.pageInit("account/personInfo","account/videoNotice",{});  // 跳转到视频见证页面
					}
					else
					{
						layerUtils.iLoading(false);
						layerUtils.iAlert(data.error_info);
					}
				});
			}
			else
			{
				layerUtils.iLoading(false);
				layerUtils.iAlert(data.error_info,-1);
			}
		},false);
	}

	/* 根据身份证号进行判断性别: 倒数第二位数字，偶数为女，基数为男 */
	function checkSexId(idno)
	{
		var value = idno.charAt(idno.length-2); // 身份证倒数第二位数字
		var isnum = value%2;
		var sexid = "";
		if(isnum == womenId)
		{
			sexid = womenId;
		}
		else
		{
			sexid = manId;
		}
		return sexid;
	}

	/* 获取用户信息*/
	function setSubmitDataParam()
	{
		var idno = $(_pageId+" .idCardNo").val();  // 身份证号
		// 判断性别，根据身份证传入男或女，也可以通过身份证号进行判断
		var sexId = "";
		if(appUtils.getPageParam("gender") == "男")
		{
			sexId = manId;
		}
		else if(appUtils.getPageParam("gender") == "女")
		{
			sexId = womenId;
		}
		else
		{
			sexId = checkSexId(idno); // 根据身份证判断
		}
		var param = {
			"user_id" : appUtils.getSStorageInfo("user_id"),
//			"infocolect_channel" : iBrowser.pc ? 0 : 3, // 信息来源渠道 0：PC  3：手机
			"infocolect_channel" : global.channelInfo,
			"idtype" : "00", // 证件类别，数据字典中定义的是 00
			"idno" : idno,  // 身份证号
			"ethnicname" : $(_pageId+" .ethnicname").val(),	 // 民族, // 民族
			"custname" : $(_pageId+" .name").val(),
			"birthday" : $(_pageId+" .idCardNo").attr("birthday"),  // 身份证修改了，出生日期也要修改
			"idbegindate" : $(_pageId+" .idBeginDate").val(),  // 证件开始日期
			"idenddate" : "",  // 证件结束日期
			"native" : $(_pageId+" .idCardAddress").val().replace(/\s+/g,""),  // 证件地址
			"policeorg" : $(_pageId+" .signDepartment").val(),  // 签发机关
			"usersex" : sexId,  // 用户性别，男 0 女 1
			"nationality" : "156",  // 屏蔽，待解决  // 国籍地区，必须写 156
			"addr" : $(_pageId+" .address").val().replace(/\s+/g,""),  // 联系地址
			"postid" : $(_pageId+" .zipCode").val(),  // 邮政编码
			"edu" : $(_pageId+" .selectDegree").val(),  // 学历代码
			"taxresident": $(_pageId+" .taxresident").val(),  // 税收居民信息代码
		//	"recommendno" : $(_pageId+" .input_form .reference").val(),  //推荐人号码
			"recommendno" : appUtils.getSStorageInfo("recommendno"),  //推荐人号码
			"profession_code" : $(_pageId+" .selectOccupation").val(),  // 职业代码
			"branchno" : appUtils.getSStorageInfo("branchno"),   // 营业部代码
			"commission" : appUtils.getSStorageInfo("commission"),  // 营业部代码佣金代码
			"provinceno" : "",  // 省份代码, 屏蔽, 待解决
			"cityno" : "",  // 城市代码
			"ipaddr" : appUtils.getSStorageInfo("ip"),  // ip 地址，在获取 短信验证码 的时候，就已经把 ip 和 mac 保存到 session 里面了
			"macaddr" : appUtils.getSStorageInfo("mac"),  // mac 地址
			"idcardmodify" : idCardModify ? 1 : 0,  // 身份证是否被手动修改，被修改传 1 ，否则传 0
			"isYourSelf":$(_pageId+" #isYourSelf .active").text()=="是"?$(_pageId+" .name").val():"",//申请人名称
			"honest_histroy":$(_pageId+" #honest_histroy .active").text()=="是"?1:0//是否有不良记录（1:有  0：没不良记录）
		};
		if($(_pageId+" .idEndDate1").val() == "长期" && $(_pageId+" #endDate").css("display") =="block"){
			param.idenddate = "3000-12-31";
		}else{
			param.idenddate = $(_pageId+" .idEndDate").val();
		}
		return param;
	}

	/* 获取职业、学历、性别列表*/
	function queryDataDict()
	{
		// 获取职业
		var profession_code = appUtils.getSStorageInfo("profession_code");  // 获取session中的职业
		var occupationalParam = {"enum_type" : "occupational"};
		service.queryDataDict(occupationalParam,function(data){
			var error_no = data.error_no,
			      error_info = data.error_info;
			$(_pageId+" .sel_list:eq(0) ul li").remove();  // 首先清空数据
			if(error_no == "0" && data.results.length != 0)
			{
				var occupational = data.results;
				for(var i=0;i<occupational.length;i++)
				{
					var str = "<li><span class='occupation0"+i+"' value='"+occupational[i].item_value+"'>"+occupational[i].item_name+"</span></li>"
					$(_pageId+" .sel_list:eq(0) ul").append(str);
					if(profession_code != "" && occupational[i].item_value == profession_code)
					{
						$(_pageId+" .selectOccupation").text(occupational[i].item_name);
						$(_pageId+" .selectOccupation").val(occupational[i].item_value);
					}
					BindSelectOccupation(i);	 // 预绑定选择职业的事件
				}
				queryAdapter();  // 再获取学历
			}
			else
			{
				layerUtils.iLoading(false);
				layerUtils.iMsg(-1,error_info);  // 提示错误信息
			}
		},false,true,handleTimeout);
	}

	/* 获取学历 */
	function queryAdapter()
	{
		var edu = appUtils.getSStorageInfo("edu");  // 获取session中的学历
		var adapterParam = {"enum_type" : "adapter"};
		service.queryDataDict(adapterParam,function(data){
			var error_no = data.error_no,
      		      error_info = data.error_info;
			$(_pageId+" .sel_list:eq(1) ul li").remove();  // 首先清空数据
			if(error_no == "0" && data.results.length != 0)
			{
				var adapter = data.results;
				for(var i=0;i<adapter.length;i++)
				{
					var str = "<li><span class='degree0"+i+"' value='"+adapter[i].item_value+"'>"+adapter[i].item_name+"</span></li>"
					$(_pageId+" .sel_list:eq(1) ul").append(str);
					if(edu != "" && adapter[i].item_value == edu)
					{
						$(_pageId+" .selectDegree").text(adapter[i].item_name);
						$(_pageId+" .selectDegree").val(adapter[i].item_value);
					}
					BindSelectDegree(i);  // 预绑定选择学历的事件
				}
				querySsjmxx();  // 获取居民税收信息
			}
			else
			{
				layerUtils.iLoading(false);
				layerUtils.iMsg(-1,error_info);  // 提示错误信息
			}
		},false,true,handleTimeout);
	}

	/* 获取税收居民信息 */
	function querySsjmxx()
	{
		var taxresident = appUtils.getSStorageInfo("taxresident");  // 获取session中的税收居民信息
		var ssjmxxParam = {"enum_type" : "ssjmxx"};
		service.queryDataDict(ssjmxxParam,function(data){
			var error_no = data.error_no,
      		      error_info = data.error_info;
			$(_pageId+" .sel_list:eq(2) ul li").remove();  // 首先清空数据
			if(error_no == "0" && data.results.length != 0)
			{
				var ssjmxx = data.results;
				for(var i=0;i<ssjmxx.length;i++)
				{
					var str = "<li><span class='resident0"+i+"' value='"+ssjmxx[i].item_value+"'>"+ssjmxx[i].item_name+"</span></li>"
					$(_pageId+" .sel_list:eq(2) ul").append(str);
					if(taxresident != "" && ssjmxx[i].item_value == taxresident)
					{
						$(_pageId+" .taxresident").text(ssjmxx[i].item_name);
						$(_pageId+" .taxresident").val(ssjmxx[i].item_value);
					}
					BindTaxresident(i);  // 预绑定选择税收居民信息的事件
				}
				querySex();  // 获取性别
			}
			else
			{
				layerUtils.iLoading(false);
				layerUtils.iMsg(-1,error_info);  // 提示错误信息
			}
		},false,true,handleTimeout);
	}

	/* 获取性别 */
	function querySex()
	{
		var sexParam = {"enum_type" : "sex"};
		service.queryDataDict(sexParam,function(data){
			var error_no = data.error_no,
	              error_info = data.error_info;
			if(error_no == "0" && data.results.length != 0)
			{
				var sex = data.results;
				var sexvalue = "";
				for(var i = 0; i<sex.length; i++)
				{
					sexvalue = sex[i].item_name;
					if(sexvalue == "男")
					{
						manId = sex[i].item_value;
					}
					if(sexvalue == "女")
					{
						womenId = sex[i].item_value;
					}
				}
			}
			else
			{
				layerUtils.iMsg(-1,error_info);  // 提示错误信息
			}
		},true,true,handleTimeout);
	}

	/* 处理请求超时 */
	function handleTimeout()
	{
		layerUtils.iConfirm("请求超时，是否重新加载？",function(){
			queryDataDict();  // 再次获取职业和学历
		});
	}

	/* 预绑定选择职业的事件 */
	function BindSelectOccupation(i)
	{
		appUtils.bindEvent($(_pageId+" .sel_list:eq(0) ul .occupation0"+i),function(e){
			$(_pageId+" .selectOccupation").attr("value",$(_pageId+" .occupation0"+i).attr("value"));
			$(this).parent().addClass("active").siblings().removeClass("active");
			var check_val =$(_pageId+" .occupation0"+i).text();
			$(_pageId+" .selectOccupation").text(check_val);
			$(_pageId+" .sel_list:eq(0)").slideUp("fast",function(){
				$("body #bodyContent").css("overflow","auto");
			});
			e.stopPropagation();	// 阻止冒泡
		});
	}

	/*  预绑定选择学历的事件 */
	function BindSelectDegree(i)
	{
		appUtils.bindEvent($(_pageId+" .sel_list:eq(1) ul .degree0"+i),function(e){
			// strong 不能用 val() 方法设置 value ，用的话无效
			$(_pageId+" .selectDegree").attr("value",$(_pageId+" .degree0"+i).attr("value"));
			$(this).parent().addClass("active").siblings().removeClass("active");
			var check_val =$(_pageId+" .degree0"+i).text();
			$(_pageId+" .selectDegree").text(check_val);
			$(_pageId+" .sel_list:eq(1)").slideUp("fast",function(){
				$("body #bodyContent").css("overflow","auto");
			});
			e.stopPropagation();  // 阻止冒泡
		});
	}

	/*  预绑定选择税收居民信息的事件 */
	function BindTaxresident(i)
	{

		appUtils.bindEvent($(_pageId+" .sel_list:eq(2) ul .resident0"+i),function(e){
			// strong 不能用 val() 方法设置 value ，用的话无效
			$(_pageId+" .taxresident").attr("value",$(_pageId+" .resident0"+i).attr("value"));
			$(this).parent().addClass("active").siblings().removeClass("active");
			var check_val =$(_pageId+" .resident0"+i).text();
			$(_pageId+" .taxresident").text(check_val);
			$(_pageId+" .sel_list:eq(2)").slideUp("fast",function(){
				$("body #bodyContent").css("overflow","auto");
			});
			e.stopPropagation();  // 阻止冒泡
		});
	}


	/* 信息提交校验 */
	function verifyInfo()
	{
		var name = $(_pageId+" .user_form .name").val();	//姓名
		var idCardNo = $(_pageId+" .user_form .idCardNo").val();	//身份证
		var ethnicname = $(_pageId+" .ethnicname").val().trim(); // 民族
		var signDepartment = $(_pageId+" .user_form .signDepartment").val();  //签发机关
		var idCardAddress = $(_pageId+" .user_form .idCardAddress").val().trim();  //证件地址
		var address = $(_pageId+" .user_form .address").val().trim(); //联系地址
		var idBeginDate = $(_pageId+" .user_form .idBeginDate").val();  //起始期限
		var idEndDate = $(_pageId+" .user_form .idEndDate").val();  //结束期限
		var zipCode = $(_pageId+" .user_form .zipCode").val();  //邮编
		var selectOccupation = $(_pageId+" .input_form .selectOccupation").text();  //职业
		var selectDegree = $(_pageId+" .input_form .selectDegree").text();  //学历
		var taxresident = $(_pageId+" .input_form .taxresident").val();  //税收居民信息
		var honest_histroy = $(_pageId+" #honest_histroy .active").text();//是否有不良记录(true:是 false:否)
		var isYourSelf = $(_pageId+" #isYourSelf .active").text(); //实际控制人、实际受益人是否是本人(true:是 false:否)
		var ischecked=$(_pageId+" .r1").is(':checked');//是否承诺提供信息真实有效
		if(name == "")
		{
			layerUtils.iMsg(-1,"姓名不能为空");
			return false;
		}
		if(idCardNo == "")
		{
			layerUtils.iMsg(-1,"身份证不能为空");
			return false;
		}

		if(ethnicname == ""){
			layerUtils.iMsg(-1,"民族不能为空");
			return false;
		}

		if(!validatorUtil.isCnAndEn(ethnicname)){
			layerUtils.iMsg(-1,"民族输入不能包含特殊字符");
			return false;
		}

		if(signDepartment == "")
		{
			layerUtils.iMsg(-1,"签发机关不能为空");
			return false;
		}
		if(idCardAddress == "")
		{
			layerUtils.iMsg(-1,"证件地址不能为空");
			return false;
		}

//		var pattern = /^[~、$^——=()（）-_0-9a-zA-Z\u4e00-\u9fa5]+$/;
		var pattern = /[！@￥%……&*+：]/;
		//验证地址是否包含特殊
		if(validatorUtil.executeExp(pattern,idCardAddress)){

			layerUtils.iMsg(-1,"证件地址不能包含特殊字符<br/>（！@￥%……&*+：）");
			return false;
		}

		//验证长度
		if(idCardAddress.len() <12){

			layerUtils.iMsg(-1,"证件地址长度输入有误");
			return false;
		}

		if(address == "")
		{
			layerUtils.iMsg(-1,"联系地址不能为空");
			return false;
		}

			//验证地址是否包含特殊
		if(validatorUtil.executeExp(pattern,address)){

			layerUtils.iMsg(-1,"联系地址不能包含特殊字符<br/>（！@￥%……&*+：）");
			return false;
		}

		//验证长度
		if(address.len() <12){

			layerUtils.iMsg(-1,"联系地址长度输入有误");
			return false;
		}

		if(idBeginDate == "")
		{
			layerUtils.iMsg(-1,"身份证起始期限不能为空");
			return false;
		}
		if($(_pageId+" .idEndDate1").val() == "长期" && $(_pageId+" #endDate").css("display") =="block"){

		}else{
			if(idEndDate == "")
			{
				layerUtils.iMsg(-1,"身份证结束期限不能为空");
				return false;
			}
		}

		if(zipCode == "")
		{
			layerUtils.iMsg(-1,"邮编不能为空");
			return false;
		}
		if(!require("validatorUtil").isPostalCode(zipCode))
		{
			layerUtils.iMsg(-1,"邮编格式不正确,请重新输入");
			return false;
		}
		if(selectOccupation == "请选择职业")
		{
			layerUtils.iMsg(-1,"职业不能为空");
			return false;
		}
		if(selectDegree == "请选择学历")
		{
			layerUtils.iMsg(-1,"学历不能为空");
			return false;
		}
		if(taxresident == "")
		{
			layerUtils.iMsg(-1,"请选择税收居民信息");
			return false;
		}else{
			if(taxresident != "1"){
				layerUtils.iMsg(-1,"系统暂不支持非居民办理线上开户业务，请至营业部临柜办理");
				return false;
			}
		}
		if(!honest_histroy || honest_histroy == "")
		{
			layerUtils.iMsg(-1,"诚信记录不能为空");
			return false;
		}else{
			if(honest_histroy == "是"){
				layerUtils.iMsg(-1,"您的诚信记录不符合证券账户开立要求，请至营业部办理");
				return false;
			}
		}
		if(!isYourSelf || isYourSelf == "")
		{
			layerUtils.iMsg(-1,"请选择'实际控制人/实际收益人'是否为本人");
			return false;
		}else{
			if(isYourSelf == "否"){
				layerUtils.iMsg(-1,"您的账户实际受益人/实际控制人不符合证券账户开立要求，请至营业部办理");
				return false;
			}
		}
		if(ischecked == false){
			layerUtils.iMsg(-1,"请确认信息真实有效并勾选签署协议");
			return false;
		}
		// 发送身份证存在性检查之前，前端验证身份证的格式
		if(!validatorUtil.isCardID(idCardNo))
		{
			layerUtils.iMsg(-1,"请输入正确的身份证号码!");
			return false;
		}
		// 对不满 18 周岁进行控制
		if(idCardNo.length == 18)
		{
			var dateStr = idCardNo.substring(6,10)+"/"+idCardNo.substring(10,12)+"/"+idCardNo.substring(12,14),
				  userAge = new Date().getTime() - Date.parse(dateStr);
			userAge = userAge / (365*24*60*60*1000);
			if(parseInt(userAge) <18)
			{
				layerUtils.iAlert("您的年龄未满 18 周岁，不允许开户!",-1);
				return false;
			}
		}
		// 验证有效期的格式
		var dateReg = /^[1-3]\d{3}-(0|1)\d-[0-3]\d$/;
		if(!(dateReg.test(idBeginDate) && validatorUtil.isDate(idBeginDate)))
		{
			layerUtils.iMsg(-1,"有效期的起始时间不符合格式!");
			return false;
		}
		if($(_pageId+" .idEndDate1").val() == "长期" && $(_pageId+" #endDate").css("display") =="block"){

		}else{
			if(!(dateReg.test(idEndDate) && validatorUtil.isDate(idEndDate)))
			{
				layerUtils.iMsg(-1,"有效期的结束时间不符合格式!");
				return false;
			}
		}
		if(new Date(idBeginDate).getTime() - new Date().getTime() >= 0)
		{
			layerUtils.iMsg(-1,"有效期的起始时间不能大于当前日期!");
			return false;
		}
		if($(_pageId+" .idEndDate1").val() != "长期" && (new Date(idEndDate).getTime() - new Date().getTime() < 0))
		{
			layerUtils.iMsg(-1,"有效期的结束时间不能小于当前日期!");
			return false;
		}
		// 校验身份证期限是否符合格式
		idBeginDate = idBeginDate.replaceAll("-","/");
		idEndDate = idEndDate.replaceAll("-","/");
		if(Date.parse(idBeginDate) >= Date.parse(idEndDate))
		{
			layerUtils.iMsg(-1,"有效期的起始时间必须小于结束时间!");
			return false;
		}
		// 页面入参的 身份证号 ，身份证号最多只允许修改五位
		if(appUtils.getPageParam("idno"))
		{
			var pageInIdCardNo = appUtils.getPageParam("idno");
		}
		else
		{
			var pageInIdCardNo = appUtils.getSStorageInfo("idCardNo");
		}
		var countDiffe = 0;  // 计算身份证修改的位数
		for(var i =0 ;i < idCardNo.length;i++)
		{
			var oneIdNo = idCardNo.charAt(i),
				  oneInIdNo =  pageInIdCardNo.charAt(i);
			if(oneIdNo != oneInIdNo)
			{
				countDiffe++;
			}
		}
		// 如果被修改的位数不等于 0 ，countDiffe 为 true
		if(countDiffe != 0)
		{
			idCardModify = true;
		}
		// 未被修改，idCardModify 为 false
		else
		{
			idCardModify = false;
		}
		if(countDiffe > 5)
		{
			utils.layerTwoButton("您好,发现您的证件号码与上传的差异过大，请您确认是否需要更换身份证?","重新上传身份证","重新确认身份证",function(){
				if(appUtils.getSStorageInfo("openChannel") == "new")
				{
					appUtils.pageInit("account/personInfo","account/uploadPhoto",{});
				}
				else if(appUtils.getSStorageInfo("openChannel") == "change")
				{
					appUtils.pageInit("account/personInfo","account/uploadPhotoChange",{});
				}
			},function(){
				return false;
			});
			return false;
		}
		// 设置出生日期
		$(_pageId+" .idCardNo").attr("birthday",idCardNo.substring(6,10)+"-"+idCardNo.substring(10,12)+"-"+idCardNo.substring(12,14));
		return true;
	}

	/**
	 * String 对象扩展方法
	 * 获取字符串的字节长度（中文2个、英文1个）
	 * */
	String.prototype.len = function() {

	    return this.replace(/[^\x00-\xff]/g, 'xx').length;
	};


	/* 日历的回调函数 */
	function calendarCallback(data)
	{
		// 回调数据中的 data 是字符串，需解析
		if(typeof(data)=="string"){
			data = JSON.parse(data);
		}
		$(_pageId+" #"+data.selector).val(data.date);
	}

	/* 清理界面元素*/
	function cleanPageElement()
	{
		$(_pageId+" .selectOccupation").html("请选择职业");  //清理职业
		$(_pageId+" .selectDegree").html("请选择学历");  //清理学历
	}

	var personInfo = {
		"init" : init,
		"bindPageEvent" : bindPageEvent,
		"pageBack" : pageBack,
		"destroy" : destroy
	};

	module.exports = personInfo;
});
