/**
 * 上传身份证照片
 */
define(function(require, exports, module){ 
	/* 私有业务模块的全局变量 begin */
	var appUtils = require("appUtils"),
		   service = require("serviceImp").getInstance(),  //业务层接口，请求数据
		   layerUtils = require("layerUtils"),
		   gconfig = require("gconfig"),
		   global = gconfig.global,
		   serverPath = global.serverPath,
		   _pageId = "#account_uploadPhoto",
		   // 填写资料的页面入参，属性由 imgState 方法赋值
			fillInformationInParam = {
				"idno" : "",	// 身份证号
				"custname" : "",	// 客户姓名
				"ethnicname" : "",	// 民族
				"native" : "",		// 证件地址
				"policeorg" : "",	// 签发机关
				"birthday" : "",	// 出生日期
				"idbegindate" : "",	// 证件开始日期
				"idenddate" : "",	// 证件结束日期
				"gender" : "",	// 用户性别
				"imgPath" : "",  // 图片的显示地址
				"imgId" : "", // 图片 id 
				"branchno": "", //营业部Id
				"commission":"",  //佣金套餐
				"postid" : ""  //邮编
			};
	var protocol = null;	//协议
	var external = require("external");
	/* 私有业务模块的全局变量 end */
	
	function init()
	{
		/*绑定右上角退出事件*/
		appUtils.bindEvent($(_pageId+" .header .btn-close"),function(){
			layerUtils.iConfirm("只需三分钟就能搞定网上开户,确定离开吗?",function(){
				var param = {
		 				"moduleName":"open",
		 				"funcNo":"50114",
		 				"params":{
		 				}
		 			};
				require("external").callMessage(param);
			},function(){},"离开","继续开户");
		});
		
		//window.imgState = imgState;  // 照片上传完成后自动调用该方法
		//cleanPageElement();  // 清理页面元素
		var branchno =  appUtils.getPageParam("branchno");
		var commission =  appUtils.getPageParam("commission");
		// 设置营业部Id
		if(branchno)
		{
			fillInformationInParam.branchno = branchno;
		}
		else
		{
			fillInformationInParam.branchno = appUtils.getSStorageInfo("branchno");
		}
		// 设置佣金套餐
		if(commission)
		{
			fillInformationInParam.commission = commission;
		}
		else
		{
			fillInformationInParam.commission = appUtils.getSStorageInfo("commission");
		}
		if(appUtils.getSStorageInfo("_prePageCode")=="account/selDepartment"){
			clearData();
		}
		$(_pageId+" .r1").addClass("checked");  // 默认选中签署协议
		queryCertAgreement();  // 获取中登证书协议
	}
	
	function bindPageEvent()
	{
		/* 点击页面隐藏按钮 */
		appUtils.bindEvent($(_pageId),function(){
			// 将按钮的自定义属性  last-media-id 设为 当前的 media-id
			$(_pageId+" .upload_btn li").attr("last-media-id",$(_pageId+" .upload_btn li:eq(0)").attr("media-id"));
			// 将按钮的自定义属性 media-id 设为 null
			$(_pageId+" .upload_btn li").attr("media-id","null");
			// 隐藏照片上传按钮
			$(_pageId+" .upload_btn").slideUp("fast");
			$(_pageId+" .upload_boxs").removeClass("active");
		});
		
		/* 绑定返回 */
		appUtils.bindEvent($(_pageId+" .header .icon_back"),function(){
			pageBack();
		});
		
		/* 绑定上传正面身份证照 */
		appUtils.bindEvent($(_pageId+" .positive"),function(e){
			
			$(_pageId+" .upload_main .negative").removeClass("active");
			var isActive = $(this).hasClass("active");
			switchCss($(_pageId+" .upload_main .positive"), isActive, 4);
			$(_pageId+" .upload_btn h5").html("上传身份证正面");
			e.stopPropagation();  // 阻止冒泡
		});
		
		/* 绑定上传反面身份证照 */
		appUtils.bindEvent($(_pageId+" .upload_main .negative"),function(e){
			$(_pageId+" .upload_main .positive").removeClass("active");
			var isActive = $(this).hasClass("active");
			switchCss($(_pageId+" .upload_main .negative"), isActive , 5);
			$(_pageId+" .upload_btn h5").html("上传身份证反面");
			e.stopPropagation();  // 阻止冒泡
		});
		
		/* 点击相册 */
		appUtils.bindEvent($(_pageId+" .upload_btn li:eq(0)"),function(e){
			// 相册上传的参数
			var phoneConfig = {
				"funcNum" : $(this).attr("media-id") == "3" ? "501526" : "501525",
				"uuid" : "index",
				"r" : Math.random(),
				"userId" : appUtils.getSStorageInfo("user_id"),
				"photoType" : $(this).attr("media-id") == "3" ? "人像正面" : "身份证",	// 影像名称
				"action" : "phone",	// 照片来源类别，phone 相册，pai 相机
				"imgType" : $(this).attr("media-id"),
				"key" : "index",	// key 和 uuid 只需要写一个
				"url" : global.serverPath,
				"clientInfo" : appUtils.getSStorageInfo("clientinfo"),	 // 从 session 中将 clientinfo 取出
				"jsessionId" : appUtils.getSStorageInfo("jsessionid"), // 从 session 中将 jsessionid 取出
				"funcNo":"60002",
				"moduleName":"open"
			};
			if(gconfig.platform == 3)
			{
				layerUtils.iLoading(true);
			}
//			require("shellPlugin").callShellMethod("carmeraPlugin",null,null,phoneConfig);
			external.callMessage(phoneConfig);
			// 隐藏照片上传按钮
			$(_pageId+" .upload_btn").slideUp("fast");
			$(_pageId+" .upload_boxs").removeClass("active");
			// 将按钮的自定义属性  last-media-id 设为 当前的 media-id
			$(_pageId+" .upload_btn li").attr("last-media-id",$(_pageId+" .upload_btn li:eq(0)").attr("media-id"));
			// 将按钮的自定义属性 media-id 设为 null
			$(_pageId+" .upload_btn li").attr("media-id","null");
			e.stopPropagation();  // 阻止冒泡
		});
		
		/* 点击拍照 */
		appUtils.bindEvent($(_pageId+" .upload_btn li:eq(1)"),function(e){
			// 相机上传的参数
			var paiConfig = {
				"funcNum" : $(this).attr("media-id") == "3" ? "501526" : "501525",
				"uuid" : "index",
				"r" : Math.random(),
				"userId" : appUtils.getSStorageInfo("user_id"),
				"photoType" : $(this).attr("media-id") == "3" ? "人像正面" : "身份证",	// 影像名称
				"action" : "pai",	// 照片来源类别，phone 相册，pai 相机
				"imgType" : $(this).attr("media-id"),
				"key" : "index",	// key 和 uuid 只需要写一个
				"url" : global.serverPath,
				"clientInfo" : appUtils.getSStorageInfo("clientinfo"), 	// 从 session 中将 clientinfo 取出
				"jsessionId" : appUtils.getSStorageInfo("jsessionid"),	// 从 session 中将 jsessionid 取出
				"funcNo":"60002",
                "moduleName":"open"
			};
			if(gconfig.platform == 3)
			{
				layerUtils.iLoading(true);
			}
			external.callMessage(paiConfig);
			// 隐藏照片上传按钮

			$(_pageId+" .upload_btn").slideUp("fast");
			$(_pageId+" .upload_boxs").removeClass("active");
			// 将按钮的自定义属性  last-media-id 设为 当前的 media-id
			$(_pageId+" .upload_btn li").attr("last-media-id",$(_pageId+" .upload_btn li:eq(0)").attr("media-id"));
			// 将按钮的自定义属性 media-id 设为 null
			$(_pageId+" .upload_btn li").attr("media-id","null");
			e.stopPropagation();  // 阻止冒泡
		});
		
		/* 绑定同意签署协议 */
		appUtils.bindEvent($(_pageId+" .r1"),function(){
			$(this).toggleClass("checked");
		});
		
		/* 绑定下一步 */
		appUtils.bindEvent($(_pageId+"  .ct_btn"),function(){
			if(validatePhoto())
			{
//				submitPhoto();  // 提交照片
				queryOpenCheckSign();
			}
		});
	}
	
	/*中登验签*/
	function queryOpenCheckSign(){
		
		// 进行协议签署
		var protocolArray = new Array(),  // 协议数组
			userid = appUtils.getSStorageInfo("user_id"),
			ipaddr  = appUtils.getSStorageInfo("ip"),
			macaddr = appUtils.getSStorageInfo("mac"),
			protocolid = protocol.econtract_no,
			summary = protocol.econtract_md5,  // 协议内容MD5,签名摘要信息
			protocolParam = {
				"protocol_id":protocolid,
				"protocol_content":summary,
				"userId":userid,
				"type": "zd"
			};
		layerUtils.iLoading(true);  // 开启等待层......
		protocolArray.push(protocolParam);   // 添加值到数组中
			// 签署协议
			var signProtocolParam = {
				"user_id" : userid,
				"jsondata" : JSON.stringify(protocolArray),
				"ipaddr" : ipaddr,
				"checksign" : 0,
				"macaddr" : macaddr
			};
			// 新开中登验签
			service.queryOpenCheckSign(signProtocolParam,submitPhoto,false);
	}
	
	/* 处理返回按钮 */
	function pageBack()
	{
		// 经纪人扫码或引流用户返回，跳过营业部选择界面
		if(appUtils.getSStorageInfo("brokerno"))
		{	
			appUtils.pageInit("account/uploadPhoto","account/msgVerify",{});
		}
		// 正常开户处理返回按钮
		else
		{
			appUtils.clearSStorage("branchno");
			appUtils.clearSStorage("branchname");
			appUtils.clearSStorage("provincename");
			appUtils.clearSStorage("cityname");					
			appUtils.pageInit("account/uploadPhoto","account/selDepartment",{});
		}
	}
	
	function clearData(){
		$(_pageId+" .positive").attr("uploaded","false");  // 标识图片未上传
		$(_pageId+" .negative").attr("uploaded","false");  // 标识图片未上传
	}
	
	function destroy()
	{
		service.destroy();
	}
	
	/* 处理点击上传身份证正面、反面效果 */
	function switchCss(ele,isActive,media)
	{
		if(isActive)
		{
			$(_pageId+" .upload_btn").slideUp("fast");
			$(_pageId+" .upload_btn li").attr("media-id","null");
		}
		else
		{
			$(_pageId+" .upload_btn").slideDown("fast");
			$(_pageId+" .upload_btn li").attr("media-id",media);
		}
		$(ele).toggleClass("active");
	}
	
	/* 清理界面元素
	 * 不能写在 destroy 方法里面，写在 destroy 里面，查看协议的时候，界面的元素也会被清理掉
	 */
	function cleanPageElement(){
		// 取消勾选协议
		$(_pageId+" .r1").removeClass("checked");
		console.log($(_pageId+" .r1").hasClass("checked"));
		// 设置 uploaded 属性为 false
		$(_pageId+" .upload_boxs").attr("uploaded",false);
		// 恢复照片 li 的内容
		$(_pageId+" .positive").text("");
		$(_pageId+" .negative").text("");
		$(_pageId+" .positive").append("<dd><p>点击上传身份证</p><h5>正 面</h5></dd>");
		$(_pageId+" .negative").append("<dd><p>点击上传身份证</p><h5>背 面</h5></dd>");
	}
	
	/* 验证图片的完整性 */
	function validatePhoto()
	{
		$(_pageId+" .upload_btn").hide();  // 隐藏照片按钮
		//var ischecked = $(_pageId+" .r1").hasClass("checked"); 
		var ischecked=$(_pageId+" .r1").is(':checked');
		//console.log(s);
		if($(_pageId+" .positive").attr("uploaded") == "false")
		{
			layerUtils.iMsg(-1,"请先上传正面照！");
			return false;
		}
		if($(_pageId+" .negative").attr("uploaded") == "false")
		{
			layerUtils.iMsg(-1,"请先上传反面照！");
			return false;
		}
		if(!ischecked)  // 检查是否勾选签署协议
		{
			layerUtils.iMsg(-1,"请先签署协议！");
			return false;
		}
		if(fillInformationInParam.idno == "")
		{
			layerUtils.iMsg(-1,"身份证正面不清晰，请重新上传");
			return false;
		}
		if(fillInformationInParam.custname == "")
		{
			layerUtils.iMsg(-1,"身份证正面不清晰，请重新上传");
			return false;
		}
		if(fillInformationInParam.birthday == "")
		{
			layerUtils.iMsg(-1,"身份证正面不清晰，请重新上传");
			return false;
		}
		if(fillInformationInParam.native == "")
		{
			layerUtils.iMsg(-1,"身份证正面不清晰，请重新上传");
			return false;
		}
		if(fillInformationInParam.idbegindate == "")
		{
			layerUtils.iMsg(-1,"身份证反面不清晰，请重新上传");
			return false;
		}
		if(fillInformationInParam.idenddate == "")
		{
			layerUtils.iMsg(-1,"身份证反面不清晰，请重新上传");
			return false;
		}
		if(fillInformationInParam.policeorg == "")
		{
			layerUtils.iMsg(-1,"身份证反面不清晰，请重新上传");
			return false;
		}
		return true;
	}
	
	/**
	 * 照片上传完成后，会自动调用 imgState 方法，但是该方法只能写在 m/index.html
	 * 或者暴露给 window ，否则无法调用
	 * 已在 init 中暴露给 window 
	 */ 
	function imgState(data)
	{
		var base64Str = (data.base64).replace(/[\n\r]*/g,"");
		if(data.error_no != 0 && data.error_no != undefined)
		{
			layerUtils.iAlert(data.error_info);
			return false;
		}
           // 身份证正面信息
           if($(_pageId+" .upload_btn li:eq(0)").attr("last-media-id") == 4)
           {
               fillInformationInParam.idno = data.idNo;  // 身份证号
               fillInformationInParam.custname = data.custName;  // 客户姓名
               fillInformationInParam.native = data.native;  // 证件地址
               fillInformationInParam.addr = data.native;  // 联系地址默认为证件地址
               fillInformationInParam.ethnicname = data.ethnicName;  // 民族
               appUtils.setSStorageInfo("ethnicname",data.ethnicname);
               fillInformationInParam.birthday = data.birthday;  // 出生日期
               fillInformationInParam.gender = data.userSex;  // 用户性别
           }
           // 身份证反面信息
           if($(_pageId+" .upload_btn li:eq(0)").attr("last-media-id") == 5)
           {
               fillInformationInParam.policeorg = data.policeOrg;  // 签发机关
               fillInformationInParam.idbegindate = data.idbeginDate;  // 证件开始日期
               fillInformationInParam.idenddate = data.idendDate;  // 证件结束日期
           }
		
		var maxheight = $(_pageId+" .upload_boxs").height()+"px";
		$(_pageId+" .upload_boxs").css("height",maxheight);  // 设置回显照片区域高度不变
		switch(Number($(_pageId+" .upload_btn li:eq(0)").attr("last-media-id")))
		{
			// 正面照
			case 4 : 
				if(fillInformationInParam.idno.length == 0)
				{
					layerUtils.iAlert("身份证号码识别失败，需重新拍摄，请注意拍摄的角度和光线！",-1);
					$(_pageId+" .positive").text("");  // 先将  li 置空
					$(_pageId+" .positive").attr("uploaded","false");  // 标识图片未上传
					$(_pageId+" .positive").append("<dd><p>点击上传身份证</p><h5>正 面</h5></dd>");
					return false;
				}
				else if(fillInformationInParam.gender.length == 0)
				{
					layerUtils.iAlert("性别识别失败，需重新拍摄，请注意拍摄的角度和光线！",-1);
					$(_pageId+" .positive").text("");  // 先将  li 置空
					$(_pageId+" .positive").attr("uploaded","false");  // 标识图片未上传
					$(_pageId+" .positive").append("<dd><p>点击上传身份证</p><h5>正 面</h5></dd>");
					return false;
				}
				$(_pageId+" .positive").text("");  // 先将  li 置空
				$(_pageId+" .positive").attr("uploaded","true");  // 标识图片已经上传
				$(_pageId+" .positive").append("<dd><img src=\""+base64Str+"\"/></dd>");  // 回显图片
				break;
			// 反面照
			case 5 : 
				if(fillInformationInParam.idbegindate.length == 0)
				{
					layerUtils.iAlert("身份证的有效期限识别失败，需重新拍摄，请注意拍摄的角度和光线！",-1);
					$(_pageId+" .negative").text("");  // 先将  li 置空
					$(_pageId+" .negative").attr("uploaded","false");  // 标识图片未上传
					$(_pageId+" .negative").append("<dd><p>点击上传身份证</p><h5>反 面</h5></dd>");
					return false;
				}
				else if(fillInformationInParam.idenddate.length == 0)
				{
					layerUtils.iAlert("身份证的有效期限识别失败，需重新拍摄，请注意拍摄的角度和光线！",-1);
					$(_pageId+" .negative").text("");  // 先将  li 置空
					$(_pageId+" .negative").attr("uploaded","false");  // 标识图片未上传
					$(_pageId+" .negative").append("<dd><p>点击上传身份证</p><h5>反 面</h5></dd>");
					return false;
				}
				$(_pageId+" .negative").text("");  // 先将  li 置空
				$(_pageId+" .negative").attr("uploaded","true");  // 标识图片已上传
				$(_pageId+" .negative").append("<dd><img src=\""+base64Str+"\"/></dd>");  // 回显图片
				break;
		}
		$(_pageId+" .upload_btn").slideUp("fast");
		if(gconfig.platform=="1"){
			$(_pageId+" .upload_boxs img").css("max-height",maxheight);  //设置图片展示大小
		}else{
			$(_pageId+" .upload_boxs img").css("height","100%");  //设置图片展示大小
		}
	}
	
	/*获取数字证书协议*/
	function queryCertAgreement()
	{
		//中登证书协议：certprotcl 自建证书协议：zjcertprotcl
		var getDigitalParam = {"category_englishname" : "certprotcl"};
		service.queryProtocolList(getDigitalParam,function(data){
			$(_pageId+" .agree_box label").html("已阅读并同意");
			var error_no = data.error_no,
		          error_info = data.error_info;
			if(error_no == 0 && data.results)
			{
				protocol = data.results[0];
				// 《中登个人数字证书申请责任书》
				if(data.results[0] != undefined)
				{
					$(_pageId+" .agree_box label").append("<a href=\"javascript:void(0)\" id=\"protocol00\">《"+data.results[0].econtract_name+"》</a>");
				}
				// 《电子签名约定书》
				if(data.results[1] != undefined)
				{
					$(_pageId+" .agree_box label").append("<a href=\"javascript:void(0)\" id=\"protocol01\">《"+data.results[1].econtract_name+"》</a>");
				}
				// 预绑定查看协议的事件
				appUtils.preBindEvent($(_pageId+" .agree_box label"),"#protocol00",function(e){
					e.stopPropagation();  // 阻止冒泡
					appUtils.pageInit("account/uploadPhoto","account/showDigitalProtocol",{"protocolId" : data.results[0].econtract_no});
				});
				// 预绑定查看协议的事件
				appUtils.preBindEvent($(_pageId+" .agree_box label"),"#protocol01",function(e){
					e.stopPropagation();  // 阻止冒泡
					appUtils.pageInit("account/uploadPhoto","account/showDigitalProtocol",{"protocolId" : data.results[1].econtract_no});
				});
			}
			else
			{
				layerUtils.iAlert(data.error_info);
			}
		},true,true,handleTimeout);
	}
	
	/* 处理请求超时 */
	function handleTimeout()
	{
		layerUtils.iConfirm("请求超时，是否重新加载？",function(){
			queryCertAgreement();  // 再次获取中登协议
		});
	}
	
	/* 提交照片 */
	function submitPhoto()
	{
		// 提交照片
		fillInformationInParam.user_id = appUtils.getSStorageInfo("user_id");
		fillInformationInParam.infocolect_channel = iBrowser.pc ? 0 : 3,  //信息来源渠道 0：PC  3：手机
		fillInformationInParam.idtype = "00";
		fillInformationInParam.idcardmodify = "0";
		fillInformationInParam.nationality = "156";
		fillInformationInParam.edu = "";
		fillInformationInParam.profession_code = "";
		fillInformationInParam.recommendno = "";
		fillInformationInParam.ipaddr = appUtils.getSStorageInfo("ip");
		fillInformationInParam.macaddr = appUtils.getSStorageInfo("mac");
		service.submitPhoto(fillInformationInParam, function(data){
			var error_no = data.error_no;
			var error_info = data.error_info;
			if(error_no ==0)
			{
				// 获取邮编
				var postnumParam = {"addr" : fillInformationInParam.native};
				service.queryPostid(postnumParam,function(data){
					var error_no = data.error_no;
					var postnum = "";  //邮编号码
					if(error_no == 0 && data.results.length != 0)
					{
						postnum = data.results[0].post;
						fillInformationInParam.postid = postnum;
					}
					/**
					 * 在切换页面之前，将图片的 base64 编码和图片识别数据保存到 session 中
					 * 转户走新开户流程时，在提交资料的时候跳转到照片上传页面，此时用户不需要上传正面照和反面照，只需补全人脸正像
					 */
					var photosInfo = {
						// 正面照 photo4，反面照 photo5
						"photo4" : "",
						"photo5" : "",
						// 填写资料的页面入参
						"fillInformationInParam" : fillInformationInParam,
						// 设置 photosInfo 的 isChangeProcess 属性，true 是更改流程，初始值为 false
						"isChangeProcess" : false
					};
					photosInfo.photo4 = $(_pageId+" .positive img").attr("src");
					photosInfo.photo5 = $(_pageId+" .negative img").attr("src");
					// 将数据保存到 session 中
					appUtils.setSStorageInfo("photosInfo",JSON.stringify(photosInfo));
					appUtils.pageInit("account/uploadPhoto","account/personInfo",fillInformationInParam);
					appUtils.clearSStorage("personInfo");  // 清除资料提交步骤标记
					appUtils.clearSStorage("currentStep");  // 清除用户步骤记录
				},false);
			}
			else
			{
				layerUtils.iLoading(false);
				layerUtils.iAlert(data.error_info,-1);
			}
		},false);
	}

	
	var uploadPhoto = {
		"init" : init,
		"bindPageEvent" : bindPageEvent,
		"pageBack" : pageBack,
		"destroy" : destroy,
		"imgState" : imgState
	};
	
	/* 暴露对外的接口 */
	module.exports = uploadPhoto;
});
