/**
 * 公告和自动升级(隐式的发送请求)
 * 首页的广告图也在此模块中调用，防止 ios 调用启动图插件而引发公告无样式的问题
 * 该模块首次加载时，执行模块中的代码，加载之后不再执行
 */
define(function(require,exports,module){
	var appUtils = require("appUtils"),
		gconfig = require("gconfig"),
		global = gconfig.global,
		service = require("serviceImp").getInstance(), //业务层接口，请求数据
		shellPlugin = require("shellPlugin"),
		utils = require("utils"),
		 base = require("base"),
		layerUtils = require("layerUtils"),
		currVersion = null;  // 当前版本号


	if(gconfig.platform == "0" || gconfig.platform == "1")  // android 、 浏览器
	{

		queryAnnouncementInfo();   // 查询公告信息

	}
	else if(gconfig.platform == "2" || gconfig.platform == "3")  // ios
	{
		setTimeout(function(){
			queryAnnouncementInfo();   // 查询公告信息
		},1500);
	}


	// 查询公告信息
	function queryAnnouncementInfo()
	{

//		window.localStorage.setItem("firstTakePhoto", "0"); //注意不能删除 为了控制拍照的时候提示不提示横屏的对话框
//		window.localStorage.setItem("firstNewTakePhoto", "0"); //注意不能删除 为了控制拍照的时候提示不提示横屏的对话框
		var queryAnnouncementInfoParam = {"funcNo" : 501602},
			abortTimeout = null,  // 丢弃请求的计时器
			xhr = invokeServer(queryAnnouncementInfoParam,function(data){
				if(abortTimeout != null)
				{
					clearTimeout(abortTimeout);
					abortTimeout = null;
				}
				if(data.error_no == 0)  // 请求成功，并且 results 不为空
				{
					if(data.results.length != 0)   // 公告数据不为空时
					{
						var flag = data.results[0].flag;
						$("#business_index .top_title p:eq(0)").html("");
						var openAccountTime = data.results[0].openAccountTime;
						appUtils.setSStorageInfo("openAccountTime",openAccountTime);
						$("#business_index .top_title p:eq(0)").text("欢迎您来天风开户！（每天"+ openAccountTime +"办理）");
						if(flag == 0){
							showAnnouncementInfo(data);  // 显示公告信息
						}
					}
			//		getCurrVersion();  // 获取当前版本号
				}
				else
				{
					TF.popWindow(data.error_info);
				}
			});
		abortTimeout = setTimeout(function(){
			xhr.abort();  // 4 秒钟请求没结束结束请求
//			getCurrVersion();  // 获取当前版本号
		},4000);
	}

	/*获取当前版本号*/
	function getCurrVersion()
	{
		shellPlugin.callShellMethod("getVersionPlugin",function(data){
			currVersion = data.version;
			getChannel();  // 获取渠道
		},function(){
			TF.popWindow("调用获取版本插件失败！");
		},{});
	}

	// 显示公告信息
	function showAnnouncementInfo(data)
	{
		announcementWindows(data);
	}

	 function announcementWindows(data){
			TF.Dialog.cfg.title ="温馨提示";
			TF.Dialog.cfg.hasTitle = true;
			TF.Dialog.cfg.btn = ["确定"];
			TF.Dialog.show();

			var oBtn = $(".kDlgBtn>a");

			$(TF.Dialog.cfg.box).html('<p class="confirm">'+data.results[0].msg+'</p>');
			oBtn.eq(0).click(function(){
				TF.Dialog.hide();
			});

		}

	// 查询广告图
	function queryAdverPic()
	{
		var queryAdverPicParam = {
				"hrefCode" : "mobindex_adver" , // 连接代码
				"channel" :	appUtils.getSStorageInfo("appChannel")
			},
			imgSrc = gconfig.imagesPath+"appAd_1.png";  // 默认图
		service.queryAdverPic(queryAdverPicParam,function(data){
			if(data.error_no == 0)
			{
				if(data.results[0] != undefined && !!data.results[0].pic_data)  // 当有数据时
				{
					imgSrc = "data:image/png;base64,"+data.results[0].pic_data;
				}
				$("#business_index .home_banner img").attr("src",imgSrc);
			}
			else
			{
				TF.popWindow(data.error_info);
			}
		},true,false);
	}

	// 获取渠道
	function getChannel()
	{
		shellPlugin.callShellMethod("getChannelPlugin",function(data){
			appUtils.setSStorageInfo("appChannel",data.channelid);  // 将 apk 的渠道保存到 session 中
			window.localStorage.setItem("appChannel",data.channelid);
			queryVersAndAddr(data.channelid);  // 查询服务器上的版本号和下载地址
		},function(){
			TF.popWindow("调用获取渠道插件失败");
		});
	}

	// 查询服务器上的版本号和下载地址
	function queryVersAndAddr(channelId)
	{
		// 查询服务器上最新的版本号
		var queryParam = {
				"funcNo" : 501560,
				"terminal_type" : gconfig.platform == "1" ? "android" : "ios",   // 类型
				"channel" : channelId  // 渠道
		};
		invokeServer(queryParam,function(data){
//			queryAdverPic();  // 查询广告图
			jihuoApp();//激活
			if(data.error_no == 0)
			{
				if(data.results.length != 0 && data.results[0].update_url != undefined)  // 服务器有数据返回时
				{
					if(gconfig.platform == 3)  // ios
					{
						updateTipsForIOS(data.results);  // IOS 自动更新的提示
					}
					else  // android 直接执行更新
					{
						execUpdate(data.results);  // 执行更新
					}
				}
			}
			else  // 查询地址失败
			{
				TF.popWindow("版本检查失败，请稍后重试！");
			}
		});
	}

	/*IOS 自动更新的提示*/
	function updateTipsForIOS(results)
	{
		var length = results.length,
			versionLatest = results[0].version,  // 最新版本号
			versionLowest = results[0].version == results[length-1].version ? "0.0.0" : results[length-1].version,  // 只有一条记录取 0
			firstEnforcement = results[0].enforcement;  // 第一条记录是否是强制更新


		if((!compareCurrAndOther(currVersion, versionLatest) && firstEnforcement == 1) || !compareCurrAndOther(currVersion,versionLowest))  // 如果第一条记录是强制更新或者当前版本小于最低版本
		{
			layerUtils.iAlert("您的当前版本过低，无法正常使用，请升级安装新版【V"+versionLatest+"】。",-1,function(){
				execUpdate(results);  // 执行升级
			},"升级");
		}
		// 当前版本大于最低版本，小于最新版本
		else if(compareCurrAndOther(currVersion, versionLowest) && !compareCurrAndOther(currVersion, versionLatest))
		{
			layerUtils.iConfirm("检测到新版本,是否更新?", function(){
				execUpdate(results);  // 执行升级
			},null, "升级", "忽略");
		}
	}

	/**
	 * 比较当前版本其他版本
	 * 当前版本比其他版大或者相等返回 true ，否则返回 false
	 */
	function compareCurrAndOther(currVersion, otherVersion)
	{
		var currVersionArr = currVersion.split("."),
			otherVersionArr = otherVersion.split(".");  // 最低版本拆分后
		if(currVersionArr[0] > otherVersionArr[0])
		{
			return true;
		}
		else if(currVersionArr[0] < otherVersionArr[0])
		{
			return false;
		}
		else if(currVersionArr[0] == otherVersionArr[0] && currVersionArr[1] > otherVersionArr[1])
		{
			return true;
		}
		else if(currVersionArr[0] == otherVersionArr[0] && currVersionArr[1] < otherVersionArr[1])
		{
			return false;
		}
		else if(currVersionArr[0] == otherVersionArr[0] && currVersionArr[1] == otherVersionArr[1] && currVersionArr[2] > otherVersionArr[2])
		{
			return true;
		}
		else if(currVersionArr[0] == otherVersionArr[0] && currVersionArr[1] == otherVersionArr[1] && currVersionArr[2] < otherVersionArr[2])
		{
			return false;
		}
		else if(currVersionArr[0] == otherVersionArr[0] && currVersionArr[1] == otherVersionArr[1] && currVersionArr[2] == otherVersionArr[2])
		{
			return true;
		}
		return false;  // 上述条件都不符合，返回 false
	}

	// 执行更新
	function execUpdate(results)
	{
		var length = results.length,
			updateParam = {
				"url" : results[0].update_url,  // 更新地址
				"versionLatest" : results[0].version,  // 最新版本号
				// 只有一条记录取 0
				"versionLowest" : results[0].version == results[length-1].version ? "0" : results[length-1].version,
				"firstEnforcement" : results[0].enforcement  // 第一条记录是否是强制更新
		};
		shellPlugin.callShellMethod("updateManagerPlugin",null,function(){
			TF.popWindow("调用版本更新插件失败！");
		},updateParam);
	}


	function GetRandomNum(Min,Max)
	{
	   var Range = Max - Min;
       var Rand = Math.random();
	   return(Min + Math.round(Rand * Range));
	}

	/*激活APP*/
	function jihuoApp()
	{

	    var radomNum  = window.localStorage.getItem("random");
		if(!radomNum)
			radomNum = GetRandomNum(1000000000000,9000000000000);

		var param = {
			"phone_seq" :radomNum,
			"conduit_no" : appUtils.getSStorageInfo("appChannel")
//			"conduit_no" : "360"
		};
		service.jiHuoApp(param,function(data){
			if(data.error_no == "0")
			{
		      window.localStorage.setItem("random", radomNum);  // 保存随机数
			}
			else
			{
				destroy();  // 清除倒计时
				layerUtils.iAlert(data.error_info);
			}
		});
	}

	/**
	 * 向后台发送请求
	 * @param param 请求的参数
	 * @param callbackFunc 请求完成的回调函数
	 * 返回值是 XMLHttpRequest 对象
	 */
	function invokeServer(param,callbackFunc)
	{
		var xhr = getXhr();
		param = parseParam(param);
		xhr.open("post",global.serverPath,true);
		xhr.setRequestHeader("Content-Type","application/x-www-form-urlencoded");   // 将数据编码成 名/值 对的表单形式形式发送给后台
		xhr.onreadystatechange = function(){
			if(xhr.readyState == 4 && xhr.status == 200)
			{
				var data = JSON.parse(xhr.responseText);
				callbackFunc(data);  // 执行回调函数
			}
		};
		xhr.send(param);
		return xhr;
	}

	// 将 JSON 对象转换为 key=value& 的方式
	function parseParam(param)
	{
		var parseResult = "";
		if(param.length == 0)
		{
			return null ;
		}
		else if(param.length == 1)
		{
			return funcNo+"="+param["funcNo"];
		}
		else
		{
			for(var p in param)
			{
				parseResult += p + "=" + param[p] + "&";
			}
			return parseResult.slice(0,-1);   // 去掉最后一个 &
		}
	}

	// 获取 ajax 对象
	function getXhr()
	{
		if(window.XMLHttpRequest)
		{
			return new XMLHttpRequest();
		}
		else
		{
			return new ActiveXObject("Microsoft.XMLHTTP");
		}
	}
});

