define(function(require, exports, module) {
	
	var appUtils = require("appUtils");
	var gconfig = require("gconfig");
	var layerUtils = require("layerUtils");
	
	/**
	 * 微信起始过渡页特殊的pageInit方法
	 * 这里没有prePageCode，而是负载元素pageCode
	 */
	function wxTransPageInit(parentPageCode, pageCode, param)
	{
		$("#stepLoadingDiv").hide();
		//增加过渡页面的标志位，兼容普通见面跳转过来
		if(!param){
			param = {};
		}
		param._isWxTransFlag = true;
		
		var pageUrl = gconfig.viewsPath + pageCode + ".html",
			pageId = pageCode.replaceAll("/", "_"),
			parentPageId = parentPageCode.replaceAll("/", "_"); //负载父元素ID
		
		try {
			if($("#"+pageId).length < 1) {
				require("ajax").loadHtml(pageUrl, function(htmlContent) {
					document.title = $(htmlContent).attr("data-pageTitle");
					$("#"+parentPageId).append(htmlContent); //保存这个page到parentPageCode
					$("#"+pageId+" img").each(function() { //设置图片scr地址，防止出错
						var src = $(this).attr("src");
						if(src && $(this).attr("data-serverImg")!="true") {
							$(this).attr("src", gconfig.imagesPath + src.substring(src.indexOf("images")+7));
						}
					});
					require.async(gconfig.scriptsPath+pageCode, function(page) {
						appUtils.setSStorageInfo("wxTransPage_pageParam", JSON.stringify(param));
						page.init(); //页面初始化
						page.bindPageEvent(); //事件绑定
					});
				}, true, false, false);
			} else {
				require.async(gconfig.scriptsPath+pageCode, function(page) {
					appUtils.setSStorageInfo("wxTransPage_pageParam", JSON.stringify(param));
					page.init(); //页面初始化
					page.bindPageEvent(); //事件绑定
				});
			}
		} catch(e) {
			console.printStackTrace(e);
		}
	}
	
	/**
	 * 微信起始过渡页特殊的getPageParam方法
	 */
	function wxGetPageParam(paramName) 
	{
		 //根据_isWxTransFlag判断，兼容普通见面跳转过来
		var jsonParam = appUtils.getSStorageInfo("wxTransPage_pageParam");
		jsonParam = JSON.parse(jsonParam);
		if(jsonParam && jsonParam._isWxTransFlag){
			if(paramName) {
				return jsonParam[paramName];
			} else {
				return jsonParam;
			}
		} else {
			return appUtils.getPageParam(paramName);
		}
	}
	
	function firstLoadFunc() {
		//修改默认的点击事件
		gconfig.triggerEventName = "mouseup";
		
		var param = {
 				"moduleName":"open",
 				"funcNo":"50100",
 				"params":{
 				}
 			};
			require("external").callMessage(param);
		/*重写框架 点击时的默认事件*/
	//	appUtils.bindEvent = bindEvent;
	//	appUtils.preBindEvent = preBindEvent;
		
	}
	
	function filterLoginOut(data){
//		var error_no = data.error_no;
//		var error_info = data.error_info;
//		if(error_no == "-999") {
//			appUtils.clearSStorage("_isLoginIn");
//			appUtils.clearSStorage("_loginInPageCode");
//			appUtils.clearSStorage("_loginInPageParam");
//			//其他清理工作...
//			layerUtils.iAlert("您还未登录或登录超时，请重新登录","-1",function(){
//				appUtils.pageInit(appUtils.getSStorageInfo("_curPageCode"), gconfig.loginPage.pageCode, gconfig.loginPage.jsonParam);
//			});
//		}
	}
	
	/**
	 * 权限校验
	 * @param checkInParam 校验判断依据
	 * "checkInParam": {
	 * 		"prePageCode": prePageCode,
	 * 		"pageCode": pageCode,
	 * 		"param": param,
	 * 		"isLastReq": isLastReq,
	 * 		"isShowWait": isShowWait,
	 * 		"isShowOverLay": isShowOverLay
	 *	}
	 */
	function checkPermission(checkInParam) {
		return true;
	}
	
	/*
	* 页面的事件绑定处理
	 * @parm ele 页面元素
	 * @param eMethod 处理函数
	 * @param etype 事件类型，pc 默认 click，移动端默认 tap
	 */
	function bindEvent(ele, eMethod, eType)
	{
		eType = eType?eType:gconfig.triggerEventName; //不传事件类型默认为click/mousedown事件
		$(ele).off(eType);
		$(ele).each(function(){
			// 计算时间的目的是防止多次点击
			var timeInv = 0;
			var _eMethod = bindFunc(eMethod, this);
			var eventFunc = function(e){
				e.originalEvent = e; // 绑定事件添加 originalEvent 属性，兼容 jquery 的代码
				if(eType.toLowerCase() == "click" || eType.toLowerCase() == "mousedown" || eType.toLowerCase() == "touchstart"){
					var time = new Date().getTime();
					if(time - timeInv > 500){
						_eMethod(e);
						timeInv = time;
					}
				}else{
					_eMethod(e);
				}
			};
			$(this).on(eType, eventFunc);
		});
	}

	/**
	 * 页面元素预绑定事件，预绑定需要知道父容器
	 * @parm parentEle 页面负载元素
	 * @parm eleSelc 预绑定元素选择器
	 * @param eMethod 处理函数
	 * @param etype 事件类型，pc 默认 click，移动端默认 tap
	 */
	function preBindEvent(parentEle, eleSelc, eMethod, eType) 
	{
		eType = eType?eType:gconfig.triggerEventName; //不传事件类型默认为click/mousedown事件
		$(parentEle).off(eType, eleSelc);
		$(parentEle).each(function(){
			// 计算时间的目的是防止多次点击
			var timeInv = 0;
			var eventFunc = function(e){
				e.originalEvent = e; // 绑定事件添加 originalEvent 属性，兼容 jquery 的代码
				var _eMethod = bindFunc(eMethod, this);
				if(eType.toLowerCase() == "click" || eType.toLowerCase() == "mousedown" || eType.toLowerCase() == "touchstart"){
					var time = new Date().getTime();
					if(time - timeInv > 500){
						_eMethod(e);
						
						// 防止预绑定事件的传播
					//	if(e.isPropagationStopped()) e.stopImmediatePropagation();
						
						timeInv = time;
					}
				}else{
					_eMethod(e);
					
					// 防止预绑定事件的传播
				//	if(e.isPropagationStopped()) e.stopImmediatePropagation();
				}
			};
			$(this).on(eType, eleSelc, eventFunc);
		});
	}
	
	/*
	 * 函数绑定
	 * @param {} fn
	 * @param {} scope
	 * @param {} args
	 * @param {} appendArgs
	 * @return {}
	 */
	 function bindFunc(fn, scope, args, appendArgs)
	 {
		if (arguments.length === 2) {
			return function() {
				return fn.apply(scope, arguments);
			};
		}
		var method = fn, slice = Array.prototype.slice, splice = Array.prototype.splice;
		return function() {
			var callArgs = args || arguments;
			if (appendArgs === true) {
				callArgs = slice.call(arguments, 0);
				callArgs = callArgs.concat(args);
			} else if (typeof appendArgs == 'number') {
				callArgs = slice.call(arguments, 0);
				var applyArgs = [ appendArgs, 0 ].concat(args);
				splice.apply(callArgs, applyArgs);
			}
			return method.apply(scope || window, callArgs);
		};
	}
   

	
	var common = {
		"firstLoadFunc": firstLoadFunc,
		"checkPermission": checkPermission,
		"wxTransPageInit": wxTransPageInit,
		"wxGetPageParam": wxGetPageParam,
		"filterLoginOut":filterLoginOut
	};
	//暴露对外的接口
	module.exports = common;
});
