/**
 * 通用工具类，将项目中的公用方法抽出来
 */
define(function(require, exports, module) {
	var appUtils = require("appUtils"),
		validatorUtil = require("validatorUtil"),
		service = require("serviceImp").getInstance(), //业务层接口，请求数据
		layerUtils = require("layerUtils"),
		gconfig = require("gconfig"),
		global = gconfig.global;
	var external = require("external");
	var platform = require("gconfig").platform;
	/**
	 * 下载证书
	 * @param callback 证书下载安装之后回调处理
	 */
	function installCertificate(callback) {
		// 下载证书，创建10位随机数
		var createKeyRandom = "1";
		for (var i = 0; i < 9; i++) {
			createKeyRandom += parseInt(Math.random() * 10) + "";
		}
		// 证书申请串，数据来源于壳子
		var pkcs10 = "",
			createKeyParam = {
				"rodam": createKeyRandom,
				"userId": appUtils.getSStorageInfo("user_id"),
				"key": "stockDelegateTradeSys",
				"funcNo": "60003"
			};
		var result = external.callMessage(createKeyParam);
		var error_no = result.error_no;
		var error_info = result.error_info;
		var result = result.results[0];
		if (error_no == "0" || error_no == "1") {
			pkcs10 = result.pkcs10;
			// 中登证书
			var param = {
				"user_id": appUtils.getSStorageInfo("user_id"),
				"pkcs10": pkcs10
			};
			var cert_type = ""; //证书类型
			// 新开调用中登证书
			if (appUtils.getSStorageInfo("openChannel") == "new") {
				cert_type = "zd";
				service.queryCompyCart(param, function(data) {
					callcert(data, cert_type, callback)
				}, false, true, function() {
					handleTimeout(callback)
				});
			} else if (appUtils.getSStorageInfo("openChannel") == "change") {
				cert_type = "zd";
				service.queryCompyCart(param, function(data) {
					callcert(data, cert_type, callback)
				}, false, true, function() {
					handleTimeout(callback)
				});
			}
		} else {
			handleTimeout(callback);
		}
	}

	/* 处理请求超时 */
	function handleTimeout(callback) {
		layerUtils.iConfirm("请求超时，是否重新加载？", function() {
			installCertificate(callback) // 再次下载证书
		});
	}

	/**
	 * 以 放大镜 的形式显示数字，如：电话号码、银行卡号
	 * @param obj 要处理的 dom 对象，一般传 this
	 * @param type 1 手机号码，2 银行卡
	 */
	function showBigNo(obj,type)
	{
		var showStr = $(obj).find("em").html();
		var originalStr = showStr.replace(/\s+/g,"");
		var styleStr = "background-color:#FFFFFF; color:#000000; border:1px solid #D83005;line-height:35px;" +
			"font-size:20px;padding:0px 5px;font-weight:bold;";
		if(type == 1)
		{
			if(originalStr.length > 3 && originalStr.length <= 7)
			{
				showStr = originalStr.substring(0,3)+" "+originalStr.substring(3,7);
			}
			else if(originalStr.length > 7 && originalStr.length <= 11)
			{
				showStr = originalStr.substring(0,3)+" "+originalStr.substring(3,7)+" "+originalStr.substring(7,11);
			}
			if(gconfig.platform == 0)  // 浏览器
			{
				styleStr += "width:145px;";
			}
			else if(gconfig.platform == 1)  // android
			{
				styleStr += "width:133px;";
			}
			else   // ios
			{
				styleStr += "width:143px;";
			}
		}
		else if(type == 2)
		{
			if(originalStr.length > 4 && originalStr.length <= 8)
			{
				showStr = originalStr.substring(0,4)+" "+originalStr.substring(4,8);
			}
			else if(originalStr.length > 8 && originalStr.length <= 12)
			{
				showStr = originalStr.substring(0,4)+" "+originalStr.substring(4,8)+" "+originalStr.substring(8,12);
			}
			else if(originalStr.length > 12 && originalStr.length <= 16)
			{
				showStr = originalStr.substring(0,4)+" "+originalStr.substring(4,8)+" "+originalStr.substring(8,12)+
					" "+originalStr.substring(12,16);
			}
			else if(originalStr.length > 16 && originalStr.length <= 19)
			{
				showStr = originalStr.substring(0,4)+" "+originalStr.substring(4,8)+" "+originalStr.substring(8,12)+
					" "+originalStr.substring(12,16)+" "+originalStr.substring(16);
			}
			else if(originalStr.length > 19 && originalStr.length <= 21)
			{
				showStr = originalStr.substring(0,4)+" "+originalStr.substring(4,8)+" "+originalStr.substring(8,12)+
					" "+originalStr.substring(12,16)+" "+originalStr.substring(16,20)+" "+originalStr.substring(20);
			}
			if(originalStr.length <= 16)
			{
				if(gconfig.platform == 0)  // 浏览器
				{
					styleStr += "width:212px;";
				}
				else if(gconfig.platform == 1)  // 安卓手机
				{
					styleStr += "width:188px;";
				}
				else   // ios
				{
					styleStr += "width:198px;";
				}
			}
			else
			{
				if(gconfig.platform == 0)  // 浏览器
				{
					styleStr += "width:253px;";
				}
				else if(gconfig.platform == 1)  // 安卓手机
				{
					styleStr += "width:225px;";
				}
				else   // ios
				{
					styleStr += "width:235px;";
				}
			}
		}
		var tipsIndex = $.layer({
				type : 4,
				closeBtn : false,
				shade : false,
				shadeClose : false,
				fix : true,
				title : false,
				area : ['auto','auto'],
				border : [10 , 0.3 , '#000', true],
				zIndex : 19930902,
				tips : {
					msg: showStr,
					follow: obj,
					guide: 0,
					isGuide: true,
					style: [styleStr, '#D83005']
				}
		});
		var widthDifference = ($(".xubox_tips").offset().left + $(".xubox_tips").width()) -  $(window).width();
		if(widthDifference > 0)
		{
			$(".xubox_tips").css("margin-left","-"+(widthDifference+10)+"px");
			$(".xubox_tips").find("i").css("margin-left",(widthDifference+10)+"px");
		}
		if(originalStr == "" && tipsIndex)
		{
			layer.close(tipsIndex);
		}
		appUtils.bindEvent($(obj),function(){
			if(tipsIndex)
			{
				layer.close(tipsIndex);
			}
		},"blur");
	}


	/**
	 * 安装证书回调方法
	 * @param callback 证书下载安装之后回调处理
	 */
	function callcert(data, cert_type, callback) {
		var error_no = data.error_no;
		var error_info = data.error_info;
		if (error_no == "0") {
			// 获取证书的内容
			var certParam = {
				"content": data.results[0].p7cert,
				"userId": appUtils.getSStorageInfo("user_id"),
				"type": cert_type,
				"funcNo": "60004"
			};
			var result = external.callMessage(certParam);
			var error_no = result.error_no;
			var error_info = result.error_info;
			if (error_no == "0" || error_no == "1") {
				callback();
			}
		} else {
			layerUtils.iLoading(false);
			layerUtils.iAlert(data.error_info, -1);
		}
	}
	/**
	 * 自定义确认框
	 * @param layerMsg 确认框的内容
	 * @param oneText 第一个按钮按钮的文本内容
	 * @param twoText 第二个按钮的文本内容
	 * @param funcOne 第一个按钮的回调函数
	 * @param funcTwo 第二个按钮的回调函数
	 */
	function layerTwoButton(layerMsg, oneText, twoText, funcOne, funcTwo) {
		var viewContent = '<div class="pop_tip notice" id="utils_confirm"><span class="icon"></span><p>' + layerMsg + '</p><div class="btn"><a href="javascript:void(0);" id="utils_confirm_one">' + oneText + '</a><a href="javascript:void(0);" id="utils_confirm_two">' + twoText + '</a></div></div>';
		var iConfirm = layerUtils.layerCustom(viewContent);
		appUtils.preBindEvent($("#utils_confirm"), " #utils_confirm_one", function() {
			if (funcOne) {
				funcOne();
			}
			layerUtils.iCustomClose();
		});
		appUtils.preBindEvent($("#utils_confirm"), " #utils_confirm_two", function() {
			if (funcTwo) {
				funcTwo();
			}
			layerUtils.iCustomClose();
		});
	}

	/**
	 * 自定义确认框
	 * @param layerMsg 确认框的内容
	 * @param oneText 第一个按钮按钮的文本内容
	 * @param twoText 第二个按钮的文本内容
	 * @param funcOne 第一个按钮的回调函数
	 * @param funcTwo 第二个按钮的回调函数
	 * @param isPersonDefine 是否是自定义处理回调    true：是  false：否
	 */
	function layerTwoButtonIsDefined(layerMsg, oneText, twoText, funcOne, funcTwo, isPersonDefine) {
		var viewContent = '<div class="pop_tip notice" style="top:20%;" id="utils_confirm"><span class="icon"></span><p>' + layerMsg + '</p><div class="btn"><a href="javascript:void(0);" id="utils_confirm_one">' + oneText + '</a><a href="javascript:void(0);" id="utils_confirm_two">' + twoText + '</a></div></div>';
		var iConfirm = layerUtils.layerCustom(viewContent);
		appUtils.preBindEvent($("#utils_confirm"), " #utils_confirm_one", function() {
			if (funcOne) {
				funcOne();
			}
			if(isPersonDefine){

			}else{
				layerUtils.iCustomClose();
			}
		});
		appUtils.preBindEvent($("#utils_confirm"), " #utils_confirm_two", function() {
			if (funcTwo) {
				funcTwo();
			}
			layerUtils.iCustomClose();
		});
	}


	/**
    	 * 通过壳子调用系统日期控件
    	 * @param obj dom 对象，一般传 this 即可
    	 */
    	function selectDate(obj) {
    		var currentDateStr = $(obj).val(),
    			yearParam = "",
    			monthParam = "",
    			dayParam = "";
    		currentDateStr = currentDateStr.replace(/-/g, "/");
    		// 如果是有效的日期串，解析年、月、日
    		if (validatorUtil.isDate(currentDateStr)) // 如果是有效的日期串，解析年、月、日
    		{
    			var tempDate = new Date(currentDateStr);
    			yearParam = tempDate.getFullYear() + "";
    			// 0~11 的值
    			monthParam = (tempDate.getMonth() + 1 + "").length == 1 ? "0" + (tempDate.getMonth() + 1) : (tempDate.getMonth() + 1) + "";
    			// 1~31 的值
    			dayParam = (tempDate.getDate() + "").length == 1 ? "0" + tempDate.getDate() : tempDate.getDate() + "";
    		}
    		else
    		{
    			var dataNew = new Date().format("yyyy/MM/dd");
    			var tempDate = new Date(dataNew);
    			yearParam = tempDate.getFullYear() + "";
    			// 0~11 的值
    			monthParam = (tempDate.getMonth() + 1 + "").length == 1 ? "0" + (tempDate.getMonth() + 1) : (tempDate.getMonth() + 1) + "";
    			// 1~31 的值
    			dayParam = (tempDate.getDate() + "").length == 1 ? "0" + tempDate.getDate() : tempDate.getDate() + "";
    		}
    		var calendarParam = {
    			"selector": $(obj).attr("id"),
    			"year": yearParam,
    			"month": monthParam,
    			"day": dayParam,
    			"moduleName":"open",
    			"funcNo":"50250"
    		};
    		console.log("调用日期插件5："+JSON.stringify(calendarParam));
    		external.callMessage(calendarParam);
    	}


	/**
	 * 以 放大镜 的形式显示数字，如：电话号码、银行卡号
	 * @param obj 要处理的 dom 对象，一般传 this
	 * @param type 1 手机号码，2 银行卡
	 */
	function showBigNo(obj, type) {
		var showStr = $(obj).val();
		var originalStr = showStr.replace(/\s+/g, "");
		var styleStr = "background-color:#FFFFFF; color:#000000; border:1px solid #D83005;line-height:35px;" +
			"font-size:20px;padding:0px 5px;font-weight:bold;";
		if (type == 1) {
			if (originalStr.length > 3 && originalStr.length <= 7) {
				showStr = originalStr.substring(0, 3) + " " + originalStr.substring(3, 7);
			} else if (originalStr.length > 7 && originalStr.length <= 11) {
				showStr = originalStr.substring(0, 3) + " " + originalStr.substring(3, 7) + " " + originalStr.substring(7, 11);
			}
			if (gconfig.platform == 0) // 浏览器
			{
				styleStr += "width:145px;";
			} else if (gconfig.platform == 1) // android
			{
				styleStr += "width:133px;";
			} else // ios
			{
				styleStr += "width:143px;";
			}
		} else if (type == 2) {
			if (originalStr.length > 4 && originalStr.length <= 8) {
				showStr = originalStr.substring(0, 4) + " " + originalStr.substring(4, 8);
			} else if (originalStr.length > 8 && originalStr.length <= 12) {
				showStr = originalStr.substring(0, 4) + " " + originalStr.substring(4, 8) + " " + originalStr.substring(8, 12);
			} else if (originalStr.length > 12 && originalStr.length <= 16) {
				showStr = originalStr.substring(0, 4) + " " + originalStr.substring(4, 8) + " " + originalStr.substring(8, 12) +
					" " + originalStr.substring(12, 16);
			} else if (originalStr.length > 16 && originalStr.length <= 19) {
				showStr = originalStr.substring(0, 4) + " " + originalStr.substring(4, 8) + " " + originalStr.substring(8, 12) +
					" " + originalStr.substring(12, 16) + " " + originalStr.substring(16);
			} else if (originalStr.length > 19 && originalStr.length <= 21) {
				showStr = originalStr.substring(0, 4) + " " + originalStr.substring(4, 8) + " " + originalStr.substring(8, 12) +
					" " + originalStr.substring(12, 16) + " " + originalStr.substring(16, 20) + " " + originalStr.substring(20);
			}
			if (originalStr.length <= 16) {
				if (gconfig.platform == 0) // 浏览器
				{
					styleStr += "width:212px;";
				} else if (gconfig.platform == 1) // 安卓手机
				{
					styleStr += "width:188px;";
				} else // ios
				{
					styleStr += "width:198px;";
				}
			} else {
				if (gconfig.platform == 0) // 浏览器
				{
					styleStr += "width:253px;";
				} else if (gconfig.platform == 1) // 安卓手机
				{
					styleStr += "width:225px;";
				} else // ios
				{
					styleStr += "width:235px;";
				}
			}
		}
		var tipsIndex = $.layer({
			type: 4,
			closeBtn: false,
			shade: false,
			shadeClose: false,
			fix: true,
			title: false,
			area: ['auto', 'auto'],
			border: [10, 0.3, '#000', true],
			zIndex: 19930902,
			tips: {
				msg: showStr,
				follow: obj,
				guide: 0,
				isGuide: true,
				style: [styleStr, '#D83005']
			}
		});
		var widthDifference = ($(".xubox_tips").offset().left + $(".xubox_tips").width()) - $(window).width();
		if (widthDifference > 0) {
			$(".xubox_tips").css("margin-left", "-" + (widthDifference + 10) + "px");
			$(".xubox_tips").find("i").css("margin-left", (widthDifference + 10) + "px");
		}
		if (originalStr == "" && tipsIndex) {
			layer.close(tipsIndex);
		}
		appUtils.bindEvent($(obj), function() {
			if (tipsIndex) {
				layer.close(tipsIndex);
			}
		}, "blur");
	}

	/**
	 * 处理 iPhone 的兼容性
	 * @param obj 待处理的 input dom 对象，一般传 this
	 * @param maxLength 最大长度
	 */
	function dealIPhoneMaxLength(obj, maxLength) {
		var currentStr = $(obj).val();
		if (currentStr.length > maxLength) {
			$(obj).val(currentStr.substring(0, maxLength));
		}
	}

	/**
	 * 超时处理
	 * @param func 超时处理函数
	 * @param isSuccess 请求是否成功
	 * gconfig.ajaxTimeout 是配置文件中配置的超时时间
	 */
	var catchTimeout = null;

	function listenTimeout(func, isSuccess) {
		if (!isSuccess) {
			if (catchTimeout != null) {
				window.clearInterval(catchTimeout);
				catchTimeout = null;
			}
			catchTimeout = window.setInterval(function() {
				// 关闭加载层
				layerUtils.iLoading(false);
				func();
			}, gconfig.ajaxTimeout * 1000);
		} else {
			window.clearTimeout(catchTimeout);
			catchTimeout = null;
		}
	}

	/**
	 * 获取手机号并填充
	 * elements 输入框名称
	 */
	function getPhoneNo(elements) {
		//调用原生获取手机号码
		var phoneParam = {
			"funcNo": "50224"
		};
		var result = external.callMessage(phoneParam);
		console.log("本机号码："+JSON.stringify(result));
		if ((result.error_no == "0" || result.error_no == "1") && (result.results != undefined)) {
			var phone = result.results[0].phone;
			var phoneReg = /^[1-9]\d{10}$/;
			// 返回的数据是 +86手机号时，截取
			if (phone.length == 14) {
				phone = phone.substring(3);
			} else if (!phoneReg.test(phone)) {
				$(elements).val("");
				return;
			}
			$(elements).val(phone);
			// 将光标移到输入框末尾
			setCursorPosition(elements);
		} else {
//			layerUtils.iMsg(-1,"获取本机号码失败！");
		}
	}

	/**
	 * 设置输入框光标的位置
	 * obj 需要设置光标位置的 input dom 对象
	 * position 光标的位置，默认是输入框的末尾
	 */
	function setCursorPosition(obj, position) {
		var text = obj.createTextRange();
		text.collapse(true);
		text.moveStart("character", position ? position : obj.value.length);
		text.select();
	}

	/**
	 * 通过壳子调用密码控件
	 * @param data 密码值
	 * @param ele 元素id
	 */
	function getInput(data, ele) {
		$(ele).val(data); // 填充密码框
	}


	/**
    	 * 关闭放大镜
    	 */
    	function closeBigNoTips()
    	{
    		var $tips = $("body>div[type='tips']");
    		if($tips.length > 0)
    		{
    			$tips.remove();
    		}
    	}
	/**
	 * 通过壳子关闭密码控件
	 */
	function onFinish() {
		$("body").css("padding-bottom", "0").scrollTop(0);
	}

	/**
	 * 功能:判断是否为银行卡号(银行卡号Luhm校验)
	 *      Luhm校验规则：16位银行卡号（19位通用）:
		    1.将未带校验位的 15（或18）位卡号从右依次编号 1 到 15（18），位于奇数位号上的数字乘以 2。
		    2.将奇位乘积的个十位全部相加，再加上所有偶数位上的数字。
		    3.将加法和加上校验位能被 10 整除。
	 * @param strValue 需要检验的银行卡字符串
	 * @returns {boolean}
	 */
	function isBankCode(strValue)
	{
		strValue = $.trim(strValue);
		if(!isNumeric(strValue)){
			return false;
		}
		var length = strValue.length;
		if (length < 8) {
			return false;
		}else if (length > 19 || length == 18) {
			return true;
		}
		var flag = true;
		var iRet = 0,i = 0,mark = 0,temp = 0;
		while(i < (length - 1)){
			mark += parseInt(strValue.charAt(i));
		    i ++;
		    temp = parseInt(strValue.charAt(i)) * 2;
		    i ++;
		    mark = Math.floor(temp / 10) + temp % 10;
		}
		if(mark % 10 == 0){
			flag = true;
		}else{
			flag = (parseInt(strValue.charAt(length - 1)) == (10 - mark % 10)) || (parseInt(strValue.charAt(length - 1)) == (mark % 10));
		}
		if(!flag){
			//开头6位
			var strBin = "10,18,30,35,37,40,41,42,43,44,45,46,47,48,49,50,51,52,53,54,55,56,58,60,61,62,63,65,68,69,84,87,88,90,91,92,93,94,95,96,97,98,99";
			if (strBin.indexOf(strValue.substring(0, 2)) > -1) {
				return true;
			}
			var lastNum = strValue.substr(strValue.length - 1, 1);    //取出最后一位（与luhm进行比较）
			var first15Num = strValue.substr(0, strValue.length - 1); //前15或18位
			var newArr = [];
			for ( var i = first15Num.length - 1; i > -1; i --) { //前15或18位倒序存进数组
				newArr.push(first15Num.substr(i, 1));
			}
			var arrJiShu = []; //奇数位*2的积 <9
			var arrJiShu2 = []; //奇数位*2的积 >9
			var arrOuShu = []; //偶数位数组
			for ( var j = 0; j < newArr.length; j++) {
				if ((j + 1) % 2 == 1) {//奇数位
					if (parseInt(newArr[j]) * 2 < 9)
						arrJiShu.push(parseInt(newArr[j]) * 2);
					else
						arrJiShu2.push(parseInt(newArr[j]) * 2);
				} else
					//偶数位
					arrOuShu.push(newArr[j]);
			}
			var jishu_child1 = [];//奇数位*2 >9 的分割之后的数组个位数
			var jishu_child2 = [];//奇数位*2 >9 的分割之后的数组十位数
			for ( var h = 0; h < arrJiShu2.length; h++) {
				jishu_child1.push(parseInt(arrJiShu2[h]) % 10);
				jishu_child2.push(parseInt(arrJiShu2[h]) / 10);
			}
			var sumJiShu = 0; //奇数位*2 < 9 的数组之和
			var sumOuShu = 0; //偶数位数组之和
			var sumJiShuChild1 = 0; //奇数位*2 >9 的分割之后的数组个位数之和
			var sumJiShuChild2 = 0; //奇数位*2 >9 的分割之后的数组十位数之和
			var sumTotal = 0;
			for ( var m = 0; m < arrJiShu.length; m++) {
				sumJiShu = sumJiShu + parseInt(arrJiShu[m]);
			}
			for ( var n = 0; n < arrOuShu.length; n++) {
				sumOuShu = sumOuShu + parseInt(arrOuShu[n]);
			}
			for ( var p = 0; p < jishu_child1.length; p++) {
				sumJiShuChild1 = sumJiShuChild1 + parseInt(jishu_child1[p]);
				sumJiShuChild2 = sumJiShuChild2 + parseInt(jishu_child2[p]);
			}
			//计算总和
			sumTotal = parseInt(sumJiShu) + parseInt(sumOuShu)
					+ parseInt(sumJiShuChild1) + parseInt(sumJiShuChild2);
			//计算Luhm值
			var k = parseInt(sumTotal) % 10 == 0 ? 10
					: parseInt(sumTotal) % 10;
			var luhm = parseInt(10 - k);
			lastNum = parseInt(lastNum);
			flag = (lastNum == luhm || luhm % lastNum == 0 || lastNum % luhm == 0 || (lastNum + luhm) == 10);
		}
		return flag;

	}
	/**
	 * 判断是否为数字
	 * @param strValue 校验的值
	 * @returns {boolean}
	 */
	function isNumeric(strValue)
	{
		if (isEmpty(strValue))
			return false;
		var pattern = /^[0-9]*$/;
	    return executeExp(pattern, strValue);
	}
	/**
	 * 执行正则表达式
	 * @param pattern 校验的正则表达式
	 * @param strValue 校验的值
	 * @returns {boolean}
	 */
	function executeExp(pattern, strValue)
	{
	    return pattern.test(strValue);
	}
	/**
	 * 判断字符串是否为空
	 * @param strValue 校验的值
	 * @returns {boolean}
	 */
	function isEmpty(strValue)
	{
		strValue = $.trim(strValue);
		return strValue.length == 0;
	}

	var utils = {
		"installCertificate": installCertificate,
		"layerTwoButton": layerTwoButton,
		"selectDate": selectDate,
		"showBigNo": showBigNo,
		"dealIPhoneMaxLength": dealIPhoneMaxLength,
		"setCursorPosition": setCursorPosition,
		"getPhoneNo": getPhoneNo,
		"getInput": getInput,
		"onFinish": onFinish,
		"showBigNo" : showBigNo,
		"isBankCode" : isBankCode,
		"closeBigNoTips":closeBigNoTips
	};

	module.exports = utils;
});
